/*
Lukas Lepicovsky
L Pass Manager
lukashi@gmail.com
www.lukashi.com


    Copyright (C) 2010  Lukas Lepicovsky LPM, 3DS Max Pass Manager

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	
	
	
	Modified by grover_gol ( http://grovergol.com/ )   2016
	
	
*/

Struct LPM_Fun_Struct
(
fn destroyAllDialogs=
(
	
	if(LPM_LoadingPreset!=true) and (callbacks.notificationParam()!=2) then
	(
		print "Close Prism Callback"
		--try destroying all dialogs

		try(destroyDialog LPM_renderRo)catch()
		try(destroyDialog LPM_netRenderRo) catch()
		try(destroyDialog LPM_progressRO)catch()
		try(destroyDialog wildCardRO) catch()
		try(destroyDialog atmRollout) catch()
		try(destroyDialog ModifierOverRollout)catch()
		try(destroyDialog SelectLayarRoll)catch()
		try(destroyDialog commonRollout) catch()
		try(destroyDialog AboutRo) catch()
		try(destroyDialog savePresetRo) catch()
		try(destroyDialog pickPasses_RO) catch()
		try(destroyDialog objectSetProps)catch()
		try(destroyDialog lightSetProps) catch()
		try(destroyDialog photoStudio_Ro) catch()
		try(destroyDialog LPMVrayGI)catch()	
		try(destroyDialog AutoMaskRoll)catch()	
		try(destroyDialog MultiformatRoll)catch()	
		try(destroyDialog LPM_treeview_rollout)catch()
		
		
		
		callbacks.removeScripts id:#closeLPM
	)
),
fn cleanSet theSet=
(
	theSet.nodes=for it in theSet.nodes where (isvalidnode it) collect it
),

fn firstChildByType theParent type=
(
	for kids in theParent.children where kids.type==type do return kids
	undefined	
),

fn GetLayerActive theNode =
(
	theObjectSet = theNode.parent.tag.value
	theLayer = theNode.text
	isLayerActive = true
	try
	(
		if (finditem theObjectSet.layersOff theLayer) != 0 then
		(
			isLayerActive = false
		)
	)
	catch()
	isLayerActive
),

fn SetLayerActive theNode =
(
	IsLayerActive = LPM_Fun.GetLayerActive theNode
	
	theObjectSet = theNode.parent.tag.value
	theLayer = theNode.text
	try
	(
		if IsLayerActive then
		(
			append theObjectSet.layersOff theLayer
		)
		else
		(
			deleteItem theObjectSet.layersOff (finditem theObjectSet.layersOff theLayer)
		)
	)
	catch()
),

fn GetNodeActive theNode =
(
	theObjectSet = theNode.parent.tag.value
	theObject = theNode.tag.value.leaf
	
	isNodeActive = true
	try
	(
		if (finditem theObjectSet.NodesOff theObject) != 0 then
		(
			isNodeActive = false
		)
	)
	catch()
	isNodeActive
),

fn SetNodeActive theNode =
(
	isNodeActive = LPM_Fun.GetNodeActive theNode
	
	theObjectSet = theNode.parent.tag.value
	theObject = theNode.tag.value.leaf
	try
	(
		if isNodeActive then
		(
			append theObjectSet.NodesOff theObject
		)
		else
		(
			deleteItem theObjectSet.NodesOff (finditem theObjectSet.NodesOff theObject)
		)
	)
	catch()
),

fn setImageIndex theNode nodeActive iconIndex disabledIndex =
(
	if(nodeActive) then
	(
		theNode.imageIndex=iconIndex
		theNode.selectedImageIndex=iconIndex
	)
	else
	(
		theNode.imageIndex=disabledIndex 
		theNode.selectedImageIndex=disabledIndex
	)
),

fn setIcon theNode=
(
	try
	(
		case theNode.tag.value.type of
		(
			"pass":
			(
				if theNode.tag.value.isAdjustment then
				(
					LPM_Fun.setImageIndex theNode theNode.tag.value.active 35 36
				)
				else
				(
					case theNode.tag.value.hideMode of
					(
						1:
						(
							LPM_Fun.setImageIndex theNode theNode.tag.value.active 46 48
						)
						2:
						(
							LPM_Fun.setImageIndex theNode theNode.tag.value.active 47 49
						)
						3:
						(
							LPM_Fun.setImageIndex theNode theNode.tag.value.active 1 11
						)
					)
				)
				
			)
			"objectSet":(
								case (theNode.tag.value.intP[1]) of
								(
									1: LPM_Fun.setImageIndex theNode true 2 2
									2: LPM_Fun.setImageIndex theNode true 12 12
									3: LPM_Fun.setImageIndex theNode true 13 13
								)
								
							)
			"lightSet":(
								case theNode.tag.value.pEnable of
								(
									1: LPM_Fun.setImageIndex theNode true 3 3
									2: LPM_Fun.setImageIndex theNode true 14 14	
									3: LPM_Fun.setImageIndex theNode true 15 15	
								)
								
							)
			"wildCard": LPM_Fun.setImageIndex theNode true 6 6
			"namedSet": LPM_Fun.setImageIndex theNode true 5 5
			"layer": 
			(
				IsLayerActive = LPM_Fun.GetLayerActive theNode
				LPM_Fun.setImageIndex theNode IsLayerActive 4 52
			)
			"object": 
			(
				IsNodeActive = LPM_Fun.GetNodeActive theNode
				LPM_Fun.setImageIndex theNode IsNodeActive 7 53
			)
			"light": LPM_Fun.setImageIndex theNode true 7 7
			"commonProps": LPM_Fun.setImageIndex theNode theNode.tag.value.active 10 22
			"renderProps": LPM_Fun.setImageIndex theNode theNode.tag.value.active 8 24
			"envProps": LPM_Fun.setImageIndex theNode theNode.tag.value.active 9 23
			"root": LPM_Fun.setImageIndex theNode true 0 0
							
			"generic":LPM_Fun.setImageIndex theNode theNode.tag.value.active 0 0
				
			"shotRoot":LPM_Fun.setImageIndex theNode true 18 18
			"shot":LPM_Fun.setImageIndex theNode theNode.tag.value.active 16 17
			"ShotPass":LPM_Fun.setImageIndex theNode theNode.tag.value.active 1 11
			"xrefObj":LPM_Fun.setImageIndex theNode theNode.tag.value.active 37 38
			"xrefScene":LPM_Fun.setImageIndex theNode theNode.tag.value.active 19 39
			"xrefLeaf":(
								case theNode.tag.value.leaf[2] of
								(
									true: LPM_Fun.setImageIndex theNode true 20 20
									false: LPM_Fun.setImageIndex theNode true 21 21	
								)
							)
			"photoStudio":LPM_Fun.setImageIndex theNode theNode.tag.value.active 25 26
			"script":LPM_Fun.setImageIndex theNode theNode.tag.value.active 29 30
			"passGroup":LPM_Fun.setImageIndex theNode theNode.tag.value.active 27 28
			"ModifierOver":LPM_Fun.setImageIndex theNode theNode.tag.value.active 32 33
			"VRayGI":LPM_Fun.setImageIndex theNode theNode.tag.value.active 40 41
			"AutoMask":LPM_Fun.setImageIndex theNode theNode.tag.value.active 42 43
			"Multiformat":LPM_Fun.setImageIndex theNode theNode.tag.value.active 50 51
			"SceneState":LPM_Fun.setImageIndex theNode theNode.tag.value.active 44 45
		)
	)catch(messagebox "Error setting icon see listener (F11) for details\nThis is often due to a memory allocation in 3ds max")
),

--returns the pass by node
fn passByNode theNode =
(
	tmpValue = undefined
	
	if(theNode!=undefined) then
	(
		tmpValue = case theNode.tag.value.type of
		(
			"pass":theNode.tag.value
			"renderProps":theNode.tag.value.parent
			"objectSet":theNode.tag.value.parent
			"lightSet":theNode.tag.value.parent
			"envProps":theNode.tag.value.parent
			"commonProps":
			(
				tmpComVal = undefined
				if theNode.tag.value.parent.type != "shot" then
				(
					tmpComVal = theNode.tag.value.parent
				)
				tmpComVal
			)
			"object":theNode.parent.parent.tag.value
			"light":theNode.parent.parent.tag.value
			"layer":theNode.parent.parent.tag.value
			"wildCard":theNode.parent.parent.tag.value
			"namedSet":theNode.parent.parent.tag.value
			"xrefObj":theNode.parent.tag.value
			"xrefScene":theNode.parent.tag.value
			"xrefLeaf":theNode.parent.parent.tag.value
			"photoStudio":theNode.parent.tag.value
			"script":theNode.parent.tag.value
			"ModifierOver":theNode.parent.tag.value
			"VRayGI":theNode.parent.tag.value
			"AutoMask":theNode.parent.tag.value
			"Multiformat":theNode.parent.tag.value
			"SceneState":theNode.parent.tag.value
			default:undefined
		)
	)
	tmpValue
),

--returns the root index of the pass
fn getIndexOfPass thePass =
(
	theRoot=thePass.parent
	j=undefined
	for i=1 to theRoot.children.count do
	(
		if theRoot.children[i]==thePass then
			j=i
	)
	j	
),

fn getAllChildren node=
(
	out=#(node)
	for i=1 to node.children.count do
	(
		join out (LPM_Fun.getAllChildren node.children[i])
	)
	out
),

fn getObjectSetArrays thePass type &objNodes &objSetArray=
(
	
	i=0
	objNodes=#()
	objSetArray=#()
	
	--collect object nodes array
	
	for objSet in thePass.children where objSet.type==type do
	(
		i+=1
		tmpCollection=#()
		objSetArray[i]=objSet
	--named sets
		for it in objSet.namedSet do
		(
			join tmpCollection (for item in selectionSets[it] collect item)
		)
	--wildcard
		for j=1 to objSet.wildCard.count do
		(
			try(
					if(objSet.wildCard[j]!="") then
						join tmpCollection (execute ("$"+objSet.wildCard[j]))
					)
					catch (messageBox ("wildCard Error"+getcurrentException()))
		)

-- Mats
		for matName in objSet.mats do
		(
			for sceneMat in scenematerials where (matName==sceneMat.name) do 
				for it in objects where it.material==sceneMat do append tmpCollection it
		)
		
	--layers
		LMan=LayerManager
		for j=1 to objSet.layers.count do
		(	
			if (finditem objSet.layersOff objSet.layers[j]) == 0 then
			(
				theLayerNodes=#()
				theLayer=LMan.getLayerfromName objSet.layers[j]
				if(theLayer != undefined) then
					theLayer.nodes &theLayerNodes
				join tmpCollection theLayerNodes
			)
		)
		--remove invalid nodes
		LPM_Fun.cleanSet objSet
		--object sets
		TmpNodesArr = #()
		TmpNodesArr = for TmpNode in objSet.nodes where ((finditem objSet.nodesOff TmpNode) == 0) collect TmpNode
		join tmpCollection TmpNodesArr


		
		for theGroup in objSet.nodes where (isGroupHead theGroup) do
		(
			join tmpCollection (for it in (LPM_Fun.getAllChildren theGroup) where isgroupmember it collect it)
			
		)
		
		if(type=="objectSet") then
			objNodes[i]=for it in tmpCollection where ((((superClassof it) ==geometryClass) or ((superClassof it) ==shape) or ((classof it) ==Container) or ((superClassof it) == helper)) and (not (iskindof it particleGroup))) collect it
		else
			objNodes[i]=for it in tmpCollection where (((superClassof it) ==light) and(not(iskindof it target)))collect it
	)
),

fn getMaskSetArrays theAutoMaskObj &MaskSetNodes &MaskSetArray=
(
	
	i=0
	MaskSetNodes=#()
	MaskSetArray=#()	
	
	--collect object nodes array
	
	for MaskSet in theAutoMaskObj.children where MaskSet.type=="MaskSet" do
	(
		i+=1
		tmpCollection=#()
		MaskSetArray[i]=MaskSet
	
	--layers
		LMan=LayerManager
		for j=1 to MaskSet.layers.count do
		(	
			theLayerNodes=#()
			theLayer=LMan.getLayerfromName MaskSet.layers[j]
			if(theLayer != undefined) then
				theLayer.nodes &theLayerNodes
			join tmpCollection theLayerNodes
		)
		--remove invalid nodes
		LPM_Fun.cleanSet MaskSet
		--object sets
		join tmpCollection MaskSet.nodes
		
		MaskSetNodes[i]=for it in tmpCollection where ((((superClassof it) ==geometryClass) or ((superClassof it) ==shape) or ((classof it) ==Container) or ((superClassof it) == helper)) and (not (iskindof it particleGroup))) collect it
		
	)
),

fn getMaskSetSingleSetObjects theAutoMaskMaskSet &MaskSetSingleSetNodes SingleSetMode:#BW =
(
	MaskSetSingleSetNodes = #()
	tmpCollection=#()
	
	case SingleSetMode of
	(
		#BW:
		(
			LMan=LayerManager
			
			for j=1 to theAutoMaskMaskSet.layersBW.count do
			(	
				theLayerNodes=#()
				theLayer=LMan.getLayerfromName theAutoMaskMaskSet.layersBW[j]
				if(theLayer != undefined) then
					theLayer.nodes &theLayerNodes
				join tmpCollection theLayerNodes
			)
			--remove invalid nodes
			theAutoMaskMaskSet.nodes = for it in theAutoMaskMaskSet.nodesBW where (isvalidnode it) collect it
			--object sets
			join tmpCollection theAutoMaskMaskSet.nodes
		)
		#Red:
		(
			LMan=LayerManager
			
			for j=1 to theAutoMaskMaskSet.layersR.count do
			(	
				theLayerNodes=#()
				theLayer=LMan.getLayerfromName theAutoMaskMaskSet.layersR[j]
				if(theLayer != undefined) then
					theLayer.nodes &theLayerNodes
				join tmpCollection theLayerNodes
			)
			--remove invalid nodes
			theAutoMaskMaskSet.nodesR = for it in theAutoMaskMaskSet.nodesR where (isvalidnode it) collect it
			--object sets
			join tmpCollection theAutoMaskMaskSet.nodesR
		)
		#Green:
		(
			LMan=LayerManager
			
			for j=1 to theAutoMaskMaskSet.layersG.count do
			(	
				theLayerNodes=#()
				theLayer=LMan.getLayerfromName theAutoMaskMaskSet.layersG[j]
				if(theLayer != undefined) then
					theLayer.nodes &theLayerNodes
				join tmpCollection theLayerNodes
			)
			--remove invalid nodes
			theAutoMaskMaskSet.nodesG = for it in theAutoMaskMaskSet.nodesG where (isvalidnode it) collect it
			--object sets
			join tmpCollection theAutoMaskMaskSet.nodesG
		)
		#Blue:
		(
			LMan=LayerManager
			
			for j=1 to theAutoMaskMaskSet.layersB.count do
			(	
				theLayerNodes=#()
				theLayer=LMan.getLayerfromName theAutoMaskMaskSet.layersB[j]
				if(theLayer != undefined) then
					theLayer.nodes &theLayerNodes
				join tmpCollection theLayerNodes
			)
			--remove invalid nodes
			theAutoMaskMaskSet.nodesB = for it in theAutoMaskMaskSet.nodesB where (isvalidnode it) collect it
			--object sets
			join tmpCollection theAutoMaskMaskSet.nodesB
		)
	)
	
	MaskSetSingleSetNodes = tmpCollection
),

fn FixOldMaskSetStyle =
(
	Tmp_All_LPM_Children = LPM_Fun.getAllChildren LPM_Root
	Tmp_All_Old_Masksets = #()
	ConvertedFlag = false
	
	for TmpAutomask in Tmp_All_LPM_Children where TmpAutomask.type == "AutoMask" do
	(
		if not TmpAutomask.MaskSetsNewStyle then
		(
			if TmpAutomask.MaskSetsRGB then
			(
				i = 0
				
				LayersCollectionsByThree = #()
				NodesCollectionsByThree = #()
				NamesCollectionsByThree = #()
				TmpLayersCollection = #(#(),#(),#())
				TmpNodesCollection = #(#(),#(),#())
				TmpNamesCollection = #("","","")
				
				MaskSetArray = for TmpMaskSet in (LPM_Fun.getAllChildren TmpAutomask) where TmpMaskSet.type == "MaskSet" collect TmpMaskSet
				
				TmpLoopsCount = MaskSetArray.count/3
				TmpLoopsCountFloat = (MaskSetArray.count/3.)
				
				if (TmpLoopsCountFloat - TmpLoopsCount)>0  then
				(
					TmpLoopsCount += 1
				)
				
				
				for j=1 to (TmpLoopsCount) do
				(
					TmpLayersCollection = #(#(),#(),#())
					TmpNodesCollection = #(#(),#(),#())
					TmpName = ""
					
					theMaskSet1 = MaskSetArray[(j-1)*3 + 1]
					theMaskSet2 = MaskSetArray[(j-1)*3 + 2]
					theMaskSet3 = MaskSetArray[(j-1)*3 + 3]
					
					if(theMaskSet1 != undefined) then
					(
						TmpLayersCollection[1] = theMaskSet1.layers
						TmpNodesCollection[1] = theMaskSet1.nodes
						TmpName += (LPM_Fun.getName theMaskSet1.name)
					)
					if(theMaskSet2 != undefined) then
					(
						TmpLayersCollection[2] = theMaskSet2.layers
						TmpNodesCollection[2] = theMaskSet2.nodes
						TmpName += "_" + (LPM_Fun.getName theMaskSet2.name)
					)
					if(theMaskSet3 != undefined) then
					(
						TmpLayersCollection[3] = theMaskSet3.layers
						TmpNodesCollection[3] = theMaskSet3.nodes
						TmpName += "_" + (LPM_Fun.getName theMaskSet3.name)
					)
					
					
					append LayersCollectionsByThree TmpLayersCollection
					append NodesCollectionsByThree TmpNodesCollection
					append NamesCollectionsByThree TmpName
				)
				
				for i = 1 to LayersCollectionsByThree.count do
				(
					theMaskSet = LPM_Fun.createMaskSet NamesCollectionsByThree[i] 5
					theMaskSet.parent = TmpAutomask
					
					theMaskSet.layersR = LayersCollectionsByThree[i][1]
					theMaskSet.nodesR = NodesCollectionsByThree[i][1]
					
					theMaskSet.layersG = LayersCollectionsByThree[i][2]
					theMaskSet.nodesG = NodesCollectionsByThree[i][2]
					
					theMaskSet.layersB = LayersCollectionsByThree[i][3]
					theMaskSet.nodesB = NodesCollectionsByThree[i][3]
				)
				
				for TmpMaskSet in MaskSetArray do
				(
					append Tmp_All_Old_Masksets TmpMaskSet
				)
			)
			else
			(
				for TmpMaskSet in (LPM_Fun.getAllChildren TmpAutomask) where TmpMaskSet.type == "MaskSet" do
				(
					TmpMaskSet.layersBW = TmpMaskSet.layers
					TmpMaskSet.nodesBW = TmpMaskSet.nodes
					
					TmpMaskSet.layers = #()
					TmpMaskSet.nodes = #()
				)
			)
			
			TmpAutomask.MaskSetsNewStyle = true
			ConvertedFlag = true
		)
	)
	
	if ConvertedFlag then
	(
		for TmpMaskSet in Tmp_All_Old_Masksets do
		(
			delete TmpMaskSet
		)
		
		messageBox "Old Mask sets have been automatically converted into new."
	)
),

fn pruneArray theArray theItem=
(
	index=1
	
	while index <= theArray.count do
	(
		if(theArray[index]==theItem) then
			deleteItem theArray index
		else
			index+=1	
	)
	theArray
),

fn getShotName theShot=
(
	base=LPM_Fun.getName theShot.name
	if(isvalidnode theshot.displayPass) then
		base+="[["+(LPM_Fun.getName theshot.displayPass.name) +"]]"
	base
),

fn saveRenderPreset =
(
	LPM_LoadingPreset=true
	
	
	
	case (classof renderers.current) of
	(
		Default_Scanline_Renderer: renderpresets.Save 0 ((getdir #temp) +"\\temp.rps") #{32,33,34}
		mental_ray_renderer: renderpresets.Save 0 ((getdir #temp) +"\\temp.rps") #{32,33,34}
		Default: renderpresets.Save 0 ((getdir #temp) +"\\temp.rps") #{32}
	)
	
	aa=fopen ((getdir #temp) +"\\temp.rps") "r"
	theSize= getFileSize ((getdir #temp) +"\\temp.rps")
	theArray=#()
	for i=1 to theSize do
	(
		theArray[i]=(ReadByte aa #unsigned)
	)
	
	fclose aa
	LPM_LoadingPreset=false
	theArray
	
),

fn loadRenderPreset theArray =
(
	LPM_LoadingPreset=true
	bb=fopen ((getdir #temp)+"\\temp2.rps")  "wb"
	for i=1 to theArray.count do
	(
		WriteByte bb theArray[i] #unsigned
	
	)
	fflush bb
	fclose bb
	
	renderpresets.LoadAll 0 ((getdir #temp)+"\\temp2.rps")
	LPM_LoadingPreset=false
),

fn saveRenderPresetNew =
(
	LPM_LoadingPreset=true
	
	
	
	case (classof renderers.current) of
	(
		Default_Scanline_Renderer: renderpresets.Save 0 ((getdir #temp) +"\\temp.rps") #{32,33,34}
		mental_ray_renderer: renderpresets.Save 0 ((getdir #temp) +"\\temp.rps") #{32,33,34}
		Default: renderpresets.Save 0 ((getdir #temp) +"\\temp.rps") #{32}
	)
	
	aa=fopen ((getdir #temp) +"\\temp.rps") "r"
	
	theSize= getFileSize ((getdir #temp) +"\\temp.rps")
	
	theArray=#()
		
	for i=1 to (theSize/8) do
	(
		append theArray (ReadLongLong aa #unsigned)
	)
	
	fclose aa
	
	theString = ""
	
	for i = 1 to theArray.count do
	(
		theString += (theArray[i] as string) +","
	)
	LPM_LoadingPreset=false
	
	theString
),


fn loadRenderPresetNew theArrayString =
(
	LPM_LoadingPreset=true
	
	theArray = filterString theArrayString ","
	for i=1 to theArray.count do
	(
		theArray[i] = theArray[i] as Integer64 
	)
	
	bb=fopen ((getdir #temp)+"\\temp2.rps")  "wb"
	for i=1 to theArray.count do
	(
		WriteLongLong bb theArray[i] #unsigned
	
	)
	fflush bb
	fclose bb
	
	renderpresets.LoadAll 0 ((getdir #temp)+"\\temp2.rps")
	
	
	LPM_LoadingPreset=false
),

fn FixOldRenderPresetStyle =
(
	Tmp_All_LPM_Children = LPM_Fun.getAllChildren LPM_Root
	Tmp_All_Old_RenderOver = #()
	ConvertFlag = false
	ConvertedRenderOver = ""
	
	Tmp_All_Old_RenderOver = for TmpRenderOver in Tmp_All_LPM_Children where (TmpRenderOver.type == "renderProps") and (TmpRenderOver.propsAlternate == "") collect TmpRenderOver
	
	if Tmp_All_Old_RenderOver.count != 0 then
	(
		ConvertFlag = queryBox "Old Render Overrides were detected. Would you like to convert it into new?" title:"Old Render Overrides"
	)
	
	if ConvertFlag then
	(
		for TmpRenderOver in Tmp_All_Old_RenderOver do
		(
			try
			(
				renderSceneDialog.close()
				
				LPM_oldRenderSettingsNew = LPM_Fun.saveRenderPresetNew()
				LPM_Fun.loadRenderPreset TmpRenderOver.props
				
				TmpRenderOver.propsAlternate=LPM_Fun.saveRenderPresetNew()
				TmpRenderOver.initialized=true
				LPM_Fun.loadRenderPresetNew LPM_oldRenderSettingsNew
				
				ConvertedRenderOver += " -  " + (LPM_Fun.getname TmpRenderOver.name) + "\n"
			)
			catch
			(
				print ("Error converting " + (LPM_Fun.getname TmpRenderOver.name))
			)
		)
		messageBox ("Render Overrides converted.\n" + ConvertedRenderOver)
	)
),

fn addToLPMLayer theNode=
(
	theLayer=LayerManager.getLayerFromName "zz-LPM"
	if(theLayer==undefined) then
	(	
		theLayer=LayerManager.newLayer()
		theLayer.setName "zz-LPM"
		theLayer.ishidden = true
		theLayer.isfrozen =true
	)
	theLayer.addNode theNode
),

fn createNode pName type=
(
	theNode=dummy()
	theNode.pos=[0,0,-1000]
	LPM_Fun.addToLPMLayer theNode

	case type of
	(
		"root":custAttributes.add theNode rootCA
		"pass":custAttributes.add theNode passCA
		"renderProps":custAttributes.add theNode renderPropsCA
		"envProps":custAttributes.add theNode envEffectCA
		"commonProps":custAttributes.add theNode commonPropsCA
		"objectSet":custAttributes.add theNode objectSetCA
		"lightSet":custAttributes.add theNode lightSetCA
		"shotRoot":custAttributes.add theNode LPM_shotRootCA
		"shot":custAttributes.add theNode LPM_shotCA
		"xrefObj":custAttributes.add theNode LPM_XrefObjCA
		"xrefScene":custAttributes.add theNode LPM_XrefSceneCA
		"photoStudio":custAttributes.add theNode photoStudio_DataCA
		"script":custAttributes.add theNode LPM_ScriptCA
		"passGroup":custAttributes.add theNode LPM_passGroupCA
		"empty":custAttributes.add theNode LPM_emptyCA
		"ModifierOver":custAttributes.add theNode ModifierOverCA
		"VRayGI":custAttributes.add theNode VRayGICA
		"AutoMask":custAttributes.add theNode AutoMaskCA
		"Multiformat":custAttributes.add theNode MultiformatCA
		"SceneState":custAttributes.add theNode SceneStateCA
		"MaskSet":custAttributes.add theNode MaskSetCA
	)
	
	pName="LPM_"+pName
	theNode.type=type
	
	if(type=="pass") or (type=="shot") or (type=="passGroup") then
		theNode.Name=uniqueName pName
	else
		theNode.name=pName

	theNode
),

fn createMaskSet theName colorType =
(
	MaskSet = LPM_Fun.createNode theName "MaskSet"
	MaskSet.colorType = colorType
	MaskSet
),

fn createPass LPM_Root=
(
	pass=LPM_Fun.createNode "Pass" "pass"
	pass.active=true
	pass.parent=LPM_Root
	pass.rootdir=(getdir #renderoutput)+"\\"
	pass.hideMode=(LPM_Fun.getIni "Settings" "objectSetDefaultHideMode" integer 1)
	pass
	
),

fn createObjectSet theName=
(
		objectSet=LPM_Fun.createNode theName "objectSet"
		objectSet.pColor=Color (random 0 200) (random 0 200) (random 0 200)
		objectSet.intP=#((LPM_Fun.getIni "Settings" "objectSetDefaultValue" integer 2), 1, 1, 1, 1, 1, 1, 1, 1, 1, 1)
		objectSet
),

fn createLightSet theName=
(
		lightSet=LPM_Fun.createNode theName "lightSet"
		lightSet.pEnable=(LPM_Fun.getIni "Settings" "objectSetDefaultValue" integer 2)
		lightSet.pCastShadows=1
		lightSet.pColorEnable=false
		lightSet.pColor=white
		lightSet
),

fn createShot LPM_Root=
(
		shotRoot=LPM_Fun.firstChildByType LPM_Root "shotRoot"
		
		shot=LPM_Fun.createNode "Shot" "shot"
		shot.active=true
		shot.parent=shotRoot
		
		theProps=LPM_Fun.createCommonProps "common props"
		theProps.parent=shot
		theProps.autoUpdateName=true
		theProps.name=LPM_Fun.generateCommonPropName theProps
		
		shot
	
),

fn createScript theName=
(
	script=LPM_Fun.createNode theName "script"
	script.active=true
	script.script=""
	script
	
),

fn createPassGroup theName=
(
	passGroup=LPM_Fun.createNode theName "passGroup"
	passGroup.active=true
	passGroup
),

fn createCommonProps theName=
(
	cp=LPM_Fun.createNode theName "commonProps"	
	cp._rendTimeType=rendTimeType
	cp._rendNThFrame=rendNThFrame
	cp._rendStart=rendStart
	cp._rendEnd=rendEnd
	cp._rendFileNumberBase=rendFileNumberBase
	cp._renderHeight=renderHeight
	cp._renderWidth=renderWidth
	cp._RendApertureWidth=getRendApertureWidth()
	cp._renderPixelAspect=renderPixelAspect
	cp._rendPickupFrames=rendPickupFrames
	cp._rendAtmosphere=rendAtmosphere
	cp._renderEffects=renderEffects 
	cp._renderDisplacements=renderDisplacements
	cp._rendColorCheck=rendColorCheck
	cp._rendFieldRender=rendFieldRender
	cp._rendHidden=rendHidden
	cp._rendSimplifyAreaLights=rendSimplifyAreaLights
	cp._rendForce2Side=rendForce2Side
	cp._rendSuperBlack=rendSuperBlack
	cp._useAdvancedLighting=RadiosityPreferences.useAdvancedLighting
	cp._computeAdvancedLighting=RadiosityPreferences.computeAdvancedLighting
	cp.initialized=true
	cp._fileType=""
	cp.preScript=""
	cp.postScript=""
	cp
),

fn editLabelByNode target tvRoot=
(
	for i=0 to (tvRoot.nodes.count-1) do
	(
		newNode=tvRoot.nodes.item[i]
		if(newNode.tag.value==target) then
			LPM_Treeview_Rollout.renameNode newNode
		
		for j=0 to (newNode.nodes.count-1) do
		if(newNode.nodes.item[j].tag.value==target) then
			LPM_Treeview_Rollout.renameNode newNode.nodes.item[j]
	)
),

--converts "1-4,5" to #(#(1,4), #(5)) undefined if invalid
fn stringToFrames theString=
(
	if not(iskindof theString string) then
		return undefined
	theArray=filterString theString ","
	flag=false
	for i in theArray collect
	(	
		it=filterString i "-"
		newItem=for j in it collect
			j as integer
		for j in newItem where j==undefined do
			return undefined
		newItem
	)
),

--gets the active time type and converts it to a string
fn convertRendTimeTypeToString=
(
	theString="0"
	case rendTimeType of
	(
		1: theString=(currenttime as integer/ticksperframe) as string
		2: theString=((animationrange.start as integer/ticksperframe) as string) + "-" +((animationrange.end as integer/ticksperframe) as string)
		3: theString=((rendstart as integer /ticksperframe) as string) + "-" +((rendend as integer/ticksperframe) as string)
		4: theString=rendPickupFrames
	)
	theString
),

fn removeBadChars theString illegalChars:undefined=
(
	if(illegalChars==undefined) then
		illegalChars="\/:?*\"|<>"
	newString=""
	for i=1 to theString.count do 
		if(findstring illegalChars theString[i])==undefined then newString+=theString[i]
	newString
	
),

fn getPassPath theRoot thePass theShot:undefined previewMode:false RendPreviewMode:true elementName:""=
(

	fn replaceByString original findStr replaceStr=
	(
		theString= copy original
		x=findString theString findStr
		safety=0
		while(x!=undefined) and (safety<1000)do
		(
			theString=replace theString x findStr.count replaceStr  		
			safety+=1
			x=findString theString findStr
		)
		theString
	)
	--Cameras----------------------------------------
	cameraString="Active_Cam"
	if(isValidNode LPM_Root.renderCamera) then
		cameraString=LPM_Root.renderCamera.name
	
	cp=LPM_Fun.firstChildByType thePass "commonProps"
	if(cp!=undefined) and (cp.cameraTgl) and (isValidNode cp._Camera) then
		cameraString=cp._Camera.name
	if(theShot!=undefined) then
	(
		cp=LPM_Fun.firstChildByType theShot "commonProps"
		if(cp!=undefined) and (cp.cameraTgl) and (isValidNode cp._Camera) then
			cameraString=cp._Camera.name
	)
	
	thePath=""
	pathString=""
	
	if(thePass.UseCustomPath) then
	(
		pathString=copy thePass.CustomPath
	)
	else
	(
		pathString=copy theRoot.pathString
	)
	
	pathString=replaceByString pathString "$Cam" cameraString
	
	
	CurDateArr = getLocalTime()
	for i = 1 to CurDateArr.count do 
	(
		CurDateArr[i] = CurDateArr[i] as string 
	)
	
	if CurDateArr[2].count == 1 then
	(
		CurDateArr[2] = "0" + CurDateArr[2]
	)
	
	if CurDateArr[4].count == 1 then
	(
		CurDateArr[4] = "0" + CurDateArr[4]
	)
	
	----------------------------------   Date Token   --------------------------------------------------
	
	CurDate = CurDateArr[4] + "." + CurDateArr[2] + "." + CurDateArr[1]
	pathString = replaceByString pathString "$Date" CurDate
	
	----------------------------------   Date Token End  ----------------------------------------------
	
	----------------------------------   Date Token   --------------------------------------------------
	
	
	CurRDate = CurDateArr[1] + "." + CurDateArr[2] + "." + CurDateArr[4]
	pathString = replaceByString pathString "$RDate" CurRDate
	
	----------------------------------   Date Token End  ----------------------------------------------
	
	----------------------------------   group Token   --------------------------------------------------
	
	tmpParent = thePass.parent
	
	if  tmpParent.type=="passGroup" then
	(
		
		tmpGroupName = LPM_Fun.getName tmpParent.name
		pathString = replaceByString pathString "$Group" tmpGroupName
	)
	else
	(
		pathString = replaceByString pathString "$Group" ""
	)
	
	----------------------------------   group Token end  --------------------------------------------------
	
	if(maxFileName=="") then
	(
		pathString=replaceByString pathString "$Max" "Unsaved_Maxfile"
		pathString=replaceByString pathString "$Ver" ""
	)
	else
	(
		pathString=replaceByString pathString "$Max" (substring maxFileName 1 (maxFileName.count - 4))
		
		
		----------------------------------   Version Token   ----------------------------------------------
		
		NumbersArr = #("0","1","2","3","4","5","6","7","8","9")
		
		CurrentfileName = maxFileName
		if CurrentfileName.count > 7 then
		(
			versionControl = substring CurrentfileName (CurrentfileName.count - 7) 4
			
			numberTestA = 0
			numberTestB = 0
			
			numberTestA = findItem NumbersArr versionControl[3]
			numberTestB = findItem NumbersArr versionControl[4]
			
			if (versionControl[1] == "_") and (versionControl[2] == "v") and (numberTestA != 0) and (numberTestB != 0)then
			(
				CurVersion = substring versionControl 2 3
				
				pathString=replaceByString pathString "$Ver" CurVersion
			)
			else
			(
				pathString=replaceByString pathString "$Ver" ""
			)
		)
		
		----------------------------------   Version Token  end ----------------------------------------------
	)
	if(theShot==undefined) then
		pathString=replaceByString pathString "$Shot" ""
	else
		pathString=replaceByString pathString "$Shot" (LPM_Fun.getName theShot.name)
	
	pathString=replaceByString pathString "$Pass" (LPM_Fun.getname thePass.name)
	if((matchpattern pathString pattern:"*$Element*") ==false) then
	(
		pathString+=ElementName 
	)
	pathString = replaceByString pathString "$Element" elementName
	
	if thePass.isAdjustment then
	(
		if thePass.AdjustmentFor != undefined then
		(
			pathString=replaceByString pathString "$APass" (LPM_Fun.getname thePass.AdjustmentFor.name)
		)
		else
		(
			pathString=replaceByString pathString "$APass" ""
		)
	)
	else
	(
		pathString=replaceByString pathString "$APass" ""
	)
	
	if(previewMode) then
		pathString="(Root)\\"+pathString
	else
	(
		if(thePass.useRootDir) then
		(
			pathString=thePass.rootDir+pathString
		)
		else
		(
			pathString=theRoot.rootdir+pathString
		)
		
		if elementName != "" then
		(
			pathString += "_"
		)
	)
	--gets rid of extraneous blackslashes
	
	isUNC=false
	if(pathString[1]=="\\" and pathString[2]=="\\") then
		isUNC=true
	
	theArray=filterString pathString "\\"
	pathString=""
	for i=1 to (theArray.count - 1) do
		pathString+=theArray[i]+"\\"
	
	pathString+=theArray[theArray.count]
	if(isUNC) then pathString="\\\\"+pathString
	

	--filetype----------------------------------------------------	
	if(LPM_Root.fileType==undefined) then LPM_Root.fileType="exr"
	theFileType=LPM_Root.fileType
	cp=LPM_Fun.firstChildByType thePass "commonProps"
		if(cp!=undefined) and (cp.fileTypeTgl) then
			theFileType=cp._fileType
	
	if(theShot!=undefined) then
	(
		cp=LPM_Fun.firstChildByType theShot "commonProps"
		if(cp!=undefined) and (cp.fileTypeTgl) then
			theFileType=cp._fileType
	)
	
	if(previewMode) then
		pathString+="####."+theFileType
	else
		pathString+="."+theFileType
	if not(RendPreviewMode) then
	(
		makeDir (getFilenamePath pathString) all:true
	)
	
	pathString
),

fn uppercase instring = -- beginning of function definition
( 
	local upper, lower, outstring -- declare variables as local
	upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ" -- set variables to literals
	lower="abcdefghijklmnopqrstuvwxyz"
	outstring=copy instring
	for i=1 to outstring.count do
	( j=findString lower outstring[i]
	if (j != undefined) do outstring[i]=upper[j]
	)
	outstring -- value will be returned as function result
), 

fn convertTimeToString frame baseNumber =
(
	intFrame= (frame as integer)/ticksperframe
	intFrame+=baseNumber
	stringFrame=intFrame as string
	numZeros=(4- stringFrame.count)
	if(intFrame>=0) then
		case numZeros of
		(
			1: stringFrame="0"+stringFrame
			2: stringFrame="00"+stringFrame
			3: stringFrame="000"+stringFrame
		)
			
	else
	(		
		case numZeros of
		(	
			1:( 
				stringFrame=subString stringFrame 2 -1
				stringFrame="-0"+stringFrame
				)
			2: (
				stringFrame=subString stringFrame 2 -1
				stringFrame="-00"+stringFrame
				)
		)
	)
	stringFrame
),

fn getIni category theKey defaultType defaultValue=
(
	val=getINISetting ( getdir #plugcfg + "\\LPM.ini" ) category theKey
	if(val=="" )then
		defaultValue
	else
		val as defaultType
),

fn setIni category theKey theValue=
(
	setINISetting ( getdir #plugcfg + "\\LPM.ini" ) category theKey (theValue as string)
),

fn getProp theNode theKey defaultType defaultValue=
(
	val = getUserProp theNode theKey
	if (val=="") or (val==undefined) then
		defaultValue
	else
		val as defaultType	
),

fn setProp theNode theKey theValue=
(
	setUserProp theNode theKey (theValue as string)
),

fn getName theString=
(
	substring theString 5 -1
),

fn generatePassName thePass=
(
	tmpName = LPM_Fun.getName thePass.name
	
	if thePass.isAdjustment and (thePass.AdjustmentFor != undefined) then
	(
		tmpName = "["+(LPM_Fun.getName (thePass.AdjustmentFor.name)) + "]" + tmpName
	)
	
	tmpName
),

fn generateCommonPropName cp=
(
	theName=""
	if(cp.autoUpdateName==false) then
		theName=(LPM_Fun.getName cp.name)
	else
	(
		if(cp.	cameraTgl) then
			if(isvalidNode cp._camera) then
				theName+=cp._camera.name+" "
			else
				theName+="Invalid Camera "			
		if(cp.timeOutputTgl) then
			case cp._rendTimeType of
			(
				1: theName+="Single "
				2: theName+="Active Segment "
				3: theName+="["+(((cp._rendStart as integer)/ticksperframe) as string)+","+(((cp._rendEnd as integer)/ticksperframe) as string)+"] "
				4: theName+="{"+cp._rendPickupFrames+"} "
			)
		if(		cp.outputSizeTgl ) then
			theName+="("+(cp._renderWidth as string )+"x"+(cp._renderHeight as string)+")"
		if(cp.usePreScript) then
			theName+=" |Pre|"
		if(cp.usePostScript) then
			theName+=" |Post|"
	)
	if(theName=="") then
		theName="Common (Auto-Name)"
	theName
),

fn GetVRayGIPath VRayGIobj theShot:undefined=
(
	VRayGIPath = ""
	
	
	if VRayGIobj.WriteMode then
	(
		thePass = VRayGIobj.parent
		if thePass != undefined then
		(
			VRayGIPath = getfilenamepath (getPassPath LPM_Root thePass theShot:theShot)
			VRayGIPath += "GI\\"
			
		)
		
	)
	else
	(
		thePass = VRayGIobj.InputPass
		if thePass != undefined then
		(
			InputPassVRayGIObj = LPM_Fun.firstChildByType thePass "VRayGI"
			
			if (InputPassVRayGIObj != undefined) then
			(
				VRayGIPath = getfilenamepath (getPassPath LPM_Root thePass theShot:theShot)
				VRayGIPath += "GI\\"
				
			)
		)
		
	)
	
	VRayGIPath
),

fn GetVRayGIFilesPath VRayGIobj theShot:undefined=
(
	VRayGIIrMapFileName =""
	VRayGILCFileName = ""
	
	TmpPath = GetVRayGIPath VRayGIobj theShot:theShot
	
	
	if TmpPath != "" then
	(
		VRayGIIrMapFileName = TmpPath + "IrMap_.vrmap"
		VRayGILCFileName = TmpPath + "LC_.vrlmap"
	)
	
	#(VRayGIIrMapFileName,VRayGILCFileName)
),

fn CheckVRayGIExist VRayGIobj theShot:undefined=
(
	VRayGIIrMapExist = false
	VRayGILCExist = false
	TmpPath = GetVRayGIPath VRayGIobj theShot:theShot
	
	
	
	if TmpPath != "" then
	(
		TmpIrMapfiles = getFiles (TmpPath + "*.vrmap")
		TmpLCfiles = getFiles (TmpPath + "*.vrlmap")
		
		if TmpIrMapfiles.count != 0 then
		(
			VRayGIIrMapExist = true
		)
		
		if TmpLCfiles.count != 0 then
		(
			VRayGILCExist = true
		)
	)
	
	#(VRayGIIrMapExist,VRayGILCExist)
),

fn generateVRayGIName VRayGIobj =
(
	IrmapModesArr = #("Single)", "Incremental)", "Animation: prerass)")
	LCModesArr = #("Single)", "Fly-through)")
	
	theName="V-Ray GI "
	
	if VRayGIobj.WriteMode then
	(
		theName += "Write "
		
		if VRayGIobj.IrMapOn then
		(
			theName += "(Ir map: " + IrmapModesArr[VRayGIobj.IrmapMode] + " "
		)
		
		if VRayGIobj.LightCacheOn then
		(
			theName += "(LC: " + LCModesArr[VRayGIobj.LightCacheMode]
		)
	)
	else
	(
		theName += "Read "
		
		TmpVRayGIExist = CheckVRayGIExist VRayGIobj
		
		if VRayGIobj.IrMapOn then
		(
			if TmpVRayGIExist[1] then
			(
				theName += "(Ir map: FOUND) "
			)
			else
			(
				theName += "(Ir map: NOT FOUND) "
			)
			
		)
		
		if VRayGIobj.LightCacheOn then
		(
			if TmpVRayGIExist[2] then
			(
				theName += "(LC: FOUND)"
			)
			else
			(
				theName += "(LC: NOT FOUND)"
			)
		)
	)

	theName
),
fn NumbersFromString TmpString =
(
	
	fn replaceByString original findStr replaceStr=
	(
		theString= copy original
		x=findString theString findStr
		safety=0
		while(x!=undefined) and (safety<1000)do
		(
			theString=replace theString x findStr.count replaceStr  		
			safety+=1
			x=findString theString findStr
		)
		theString
	)
	
	TmpNumbers = #()
	
	TmpString = replaceByString TmpString " " ""
	
	TmpStringsArr = FilterString TmpString ","
	
	for i = 1 to TmpStringsArr.count do 
	(
		TmpNumer = TmpStringsArr[i] as integer
		
		if TmpNumer != undefined then
		(
			appendIfUnique TmpNumbers TmpNumer
		)
		else
		(
			TmpIntervalArr =  FilterString TmpStringsArr[i] "-"
			
			if TmpIntervalArr.count == 2 then
			(
				TmpStartNumber =  TmpIntervalArr[1] as integer
				TmpEndNumber =  TmpIntervalArr[2] as integer
				
				
				
				if (TmpStartNumber  != undefined) and (TmpEndNumber  != undefined) then
				(
					if TmpEndNumber>TmpStartNumber then
					(
						TmpIntervalNumbers =( for j = TmpStartNumber to TmpEndNumber collect j)
						
						for j= 1 to TmpIntervalNumbers.count do 
						(
							appendIfUnique TmpNumbers TmpIntervalNumbers[j]
						)
					)
				)
			)
		)
	)
	
	TmpNumbers
),

fn CreateBWmask TmpObjArr TmpName =
(
	REManager = maxOps.GetCurRenderElementMgr()
	REcount = REManager.NumRenderElements()
	
	vr=renderers.current
	theRenderer=(classof vr) as string
	
	try
	(
		if (findString theRenderer "V_Ray" !=undefined) then
		(
			REManager.AddRenderElement (MultiMatteElement elementname:TmpName)
			
			theElement = REManager.GetRenderElement REcount
			
			theElement.enabled = true
			theElement.R_gbufIDOn = theElement.G_gbufIDOn = theElement.B_gbufIDOn = false
			theElement.redListType = theElement.greenListType = theElement.blueListType = 1
			
			theElement.redList = theElement.greenList = theElement.blueList = TmpObjArr
		)

		if (findString theRenderer "Corona" !=undefined) then
		(
			REManager.AddRenderElement (CMasking_Mask elementname:TmpName)
			
			theElement = REManager.GetRenderElement REcount
			
			theElement.enabled = true
			theElement.mode = 0
			theElement.nodesMonoOn = true
			theElement.nodesMonoIncludeMod = true
			theElement.nodesMono = TmpObjArr
		)
		
		if (findString theRenderer "Redshift" !=undefined) then
		(
			/* 
			REManager.AddRenderElement (RsPuzzleMatte elementname:TmpName)
			
			theElement = REManager.GetRenderElement REcount
			
			theElement.enabled = true
			
			theElement.R_gbufIDOn = theElement.G_gbufIDOn = theElement.B_gbufIDOn = false
			theElement.redListType = theElement.greenListType = theElement.blueListType = 1
			theElement.redList = theElement.greenList = theElement.blueList = TmpObjArr
			 */
		)
	)
	catch()
),

fn CreateRGBmask TmpObjArr1 TmpObjArr2 TmpObjArr3 TmpName =
(
	REManager = maxOps.GetCurRenderElementMgr()
	REcount = REManager.NumRenderElements()
	
	
	vr=renderers.current
	theRenderer=(classof vr) as string
	
	try
	(
		if (findString theRenderer "V_Ray" !=undefined) then
		(
			REManager.AddRenderElement (MultiMatteElement elementname:TmpName)
			
			theElement = REManager.GetRenderElement REcount
			
			theElement.enabled = true
			theElement.R_gbufIDOn = theElement.G_gbufIDOn = theElement.B_gbufIDOn = false
			theElement.redListType = theElement.greenListType = theElement.blueListType = 1
			
			theElement.redList = TmpObjArr1
			theElement.greenList = TmpObjArr2
			theElement.blueList = TmpObjArr3
		)
		
		if (findString theRenderer "Corona" !=undefined) then
		(
			REManager.AddRenderElement (CMasking_Mask elementname:TmpName)
			
			theElement = REManager.GetRenderElement REcount
			
			theElement.enabled = true
			theElement.mode = 1
			theElement.nodesROn = theElement.nodesGOn =theElement.nodesBOn = true
			theElement.nodesRIncludeMod = theElement.nodesGIncludeMod = theElement.nodesBIncludeMod = true
			theElement.nodesR = TmpObjArr1
			theElement.nodesG = TmpObjArr2
			theElement.nodesB = TmpObjArr3
		)
		
		if (findString theRenderer "Redshift" !=undefined) then
		(
			/* 
			REManager.AddRenderElement (RsPuzzleMatte elementname:TmpName)
			
			theElement = REManager.GetRenderElement REcount
			
			theElement.enabled = true
			 */
		)
	)
	catch()
),

fn CreateIDBWmask TmpNumbersArr isMatID:false =
(
	REManager = maxOps.GetCurRenderElementMgr()
	REcount = REManager.NumRenderElements()
	
	
	vr=renderers.current
	theRenderer=(classof vr) as string
	
	try
	(
		if (findString theRenderer "V_Ray" !=undefined) then
		(
			for i = 1 to TmpNumbersArr.count do 
			(
				if isMatID then
				(
					REManager.AddRenderElement (MultiMatteElement elementname:("am_mID_" + (i as String)))
				)
				else
				(
					REManager.AddRenderElement (MultiMatteElement elementname:("am_oID_" + (i as String)))
				)
				
				theElement = REManager.GetRenderElement (REcount+i-1)
				
				theElement.enabled = true
				theElement.R_gbufIDOn = theElement.G_gbufIDOn = theElement.B_gbufIDOn = true
				theElement.R_gbufID = theElement.G_gbufID = theElement.B_gbufID = TmpNumbersArr[i]
				theElement.MatID = isMatID
			)
		)
		
		if (findString theRenderer "Redshift" !=undefined) then
		(
			for i = 1 to TmpNumbersArr.count do 
			(
				if isMatID then
				(
					REManager.AddRenderElement (RsPuzzleMatte elementname:("am_mID_" + (i as String)))
					
					theElement = REManager.GetRenderElement (REcount+i-1)
					
					theElement.enabled = true
					theElement.puzzleMatteMode = 0
					theElement.redID = theElement.greenID = theElement.blueID = TmpNumbersArr[i]
				)
				else
				(
					REManager.AddRenderElement (RsPuzzleMatte elementname:("am_oID_" + (i as String)))
					
					theElement = REManager.GetRenderElement (REcount+i-1)
					
					theElement.enabled = true
					theElement.puzzleMatteMode = 1
					theElement.redID = theElement.greenID = theElement.blueID = TmpNumbersArr[i]
				)
				
			)
		)
		
		if (findString theRenderer "Corona" !=undefined) then
		(
			for i = 1 to TmpNumbersArr.count do 
			(
				if isMatID then
				(
					REManager.AddRenderElement (CMasking_Mask elementname:("am_mID_" + (i as String)))
					
					theElement = REManager.GetRenderElement (REcount+i-1)
					
					theElement.enabled = true
					
					theElement.mode = 0
					theElement.materialMonoOn = true
					theElement.materialMono = TmpNumbersArr[i]
				)
				else
				(
					REManager.AddRenderElement (CMasking_Mask elementname:("am_oID_" + (i as String)))
					
					theElement = REManager.GetRenderElement (REcount+i-1)
					
					theElement.enabled = true
					
					theElement.mode = 0
					theElement.objectMonoOn = true
					theElement.objectMono = TmpNumbersArr[i]
				)
				
			)
		)
	)
	catch()
),

fn CreateIDRGBmask TmpNumbersArr isMatID:false =
(
	REManager = maxOps.GetCurRenderElementMgr()
	REcount = REManager.NumRenderElements()
	
	TmpIDinElementCount = 0
	TmpElemNumb = -1
	
	
	
	vr=renderers.current
	theRenderer=(classof vr) as string
	
	try
	(
		if (findString theRenderer "V_Ray" !=undefined) then
		(
			for i = 1 to TmpNumbersArr.count do 
			(
				TmpIDinElementCount += 1
				
				theElement = 0
				
				if (REcount+TmpElemNumb)>=0 then
				(
					theElement = REManager.GetRenderElement (REcount+TmpElemNumb)
				)
				
				if TmpIDinElementCount == 1 then
				(
					TmpElemNumb += 1
					
					if isMatID then
					(
						REManager.AddRenderElement (MultiMatteElement elementname:("am_mID_" + ((TmpElemNumb + 1) as String)))
					)
					else
					(
						REManager.AddRenderElement (MultiMatteElement elementname:("am_oID_" + ((TmpElemNumb + 1) as String)))
					)
					
					theElement = REManager.GetRenderElement (REcount+TmpElemNumb)
					
					theElement.R_gbufIDOn = theElement.G_gbufIDOn = theElement.B_gbufIDOn = false
					theElement.MatID = isMatID
					theElement.enabled = true
				)
				
				case TmpIDinElementCount of
				(
					1:
					(
						theElement.R_gbufIDOn = true
						theElement.R_gbufID = TmpNumbersArr[i] as integer
					)
					2:
					(
						theElement.G_gbufIDOn = true
						theElement.G_gbufID = TmpNumbersArr[i] as integer
					)
					3:
					(
						theElement.B_gbufIDOn = true
						theElement.B_gbufID = TmpNumbersArr[i] as integer
						TmpIDinElementCount = 0
					)
				)
				
				
			)
		)
		
		if (findString theRenderer "Redshift" !=undefined) then
		(
			for i = 1 to TmpNumbersArr.count do 
			(
				TmpIDinElementCount += 1
				
				theElement = 0
				
				if (REcount+TmpElemNumb)>=0 then
				(
					theElement = REManager.GetRenderElement (REcount+TmpElemNumb)
				)
				
				if TmpIDinElementCount == 1 then
				(
					TmpElemNumb += 1
					
					if isMatID then
					(
						REManager.AddRenderElement (RsPuzzleMatte elementname:("am_mID_" + ((TmpElemNumb + 1) as String)))
					)
					else
					(
						REManager.AddRenderElement (RsPuzzleMatte elementname:("am_oID_" + ((TmpElemNumb + 1) as String)))
					)
					
					theElement = REManager.GetRenderElement (REcount+TmpElemNumb)
					
					if isMatID then
					(
						theElement.puzzleMatteMode = 0
					)
					else
					(
						theElement.puzzleMatteMode = 1
					)
				)
				
				case TmpIDinElementCount of
				(
					1:
					(
						theElement.redID = TmpNumbersArr[i] as integer
					)
					2:
					(
						theElement.greenID = TmpNumbersArr[i] as integer
					)
					3:
					(
						theElement.blueID = TmpNumbersArr[i] as integer
						TmpIDinElementCount = 0
					)
				)
				
				
			)
		)
		
		if (findString theRenderer "Corona" !=undefined) then
		(
			for i = 1 to TmpNumbersArr.count do 
			(
				TmpIDinElementCount += 1
				
				theElement = 0
				
				if (REcount+TmpElemNumb)>=0 then
				(
					theElement = REManager.GetRenderElement (REcount+TmpElemNumb)
				)
				
				if TmpIDinElementCount == 1 then
				(
					TmpElemNumb += 1
					
					if isMatID then
					(
						REManager.AddRenderElement (CMasking_Mask elementname:("am_mID_" + ((TmpElemNumb + 1) as String)))
					)
					else
					(
						REManager.AddRenderElement (CMasking_Mask elementname:("am_oID_" + ((TmpElemNumb + 1) as String)))
					)
					
					theElement = REManager.GetRenderElement (REcount+TmpElemNumb)
					
					theElement.mode = 1
					theElement.enabled = true
				)
				
				if isMatID then
				(
					case TmpIDinElementCount of
					(
						1:
						(
							theElement.materialROn = true
							theElement.materialR = TmpNumbersArr[i] as integer
						)
						2:
						(
							theElement.materialGOn = true
							theElement.materialG = TmpNumbersArr[i] as integer
						)
						3:
						(
							theElement.materialBOn = true
							theElement.materialB = TmpNumbersArr[i] as integer
							TmpIDinElementCount = 0
						)
					)
				)
				else
				(
					case TmpIDinElementCount of
					(
						1:
						(
							theElement.objectROn = true
							theElement.objectR = TmpNumbersArr[i] as integer
						)
						2:
						(
							theElement.objectGOn = true
							theElement.objectG = TmpNumbersArr[i] as integer
						)
						3:
						(
							theElement.objectBOn = true
							theElement.objectB = TmpNumbersArr[i] as integer
							TmpIDinElementCount = 0
						)
					)
				)
				
			)
		)
	)
	catch()
),


renderBarProgress,

fn init_LPM_renderProgress_Ro thePass theShot =
(
	global  LPM_renderProgress_Ro
	rollout LPM_renderProgress_Ro  "Render Progress" width:200 height:95
	(
		label shotLabel "Shot: --" align:#left
		label passLabel "Pass:" align:#left
		label escLabel "Hold Esc to cancel all Passes/Shots." align:#left
		progressBar theBar
		hyperlink warning "No Warnings/Errors" color:(color 6 135 6)
	)
	
	createDialog LPM_renderProgress_Ro pos:(LPM_FUN.getROPos LPM_renderProgress_Ro.width)
	
	if(isvalidnode theShot) then
		LPM_renderProgress_Ro.shotLabel.text="Shot:"+(LPM_Fun.getname theShot.name)
	
	LPM_renderProgress_Ro.passLabel.text="Pass:"+(LPM_Fun.generatePassName thePass)
	
	if(renderBarProgress!=undefined) then
		LPM_renderProgress_Ro.theBar.value=renderBarProgress
),

fn getROPos dialogWidth=
(
	
	left=LPM_Fun.getIni "Settings" "dialogAlignLeft" booleanClass true

	thePos=(point2 0 0)
	if(LPM_Treeview_rollout!=undefined) and (LPM_Treeview_rollout.open) then
	(
		thePos=(GetDialogPos LPM_Treeview_rollout)
	)

	if(thePos.x<dialogWidth) then
		left=false
	
	if(left) then
		thePos=thePos-[dialogWidth+20,0]
	else
		thePos=thePos+[LPM_Treeview_Rollout.width+20,0]
	thePos

),

fn launchNetworkRender=
(
	ProjRenderPathTest = CheckProjRenderPath()
	
	if ProjRenderPathTest[1] then
	(
		ProjRenderPath = getProjRenderPath()
		if ProjRenderPath != LPM_Root.rootDir then
		(
			if (queryBox "Saving directory is not correct. Continue?") then
			(
				if(maxfilepath=="") then
				(
					messagebox "Please save the max file before a net render"
					return false
				)
				
				theNetworkType=LPM_Fun.getIni "Settings" "Network Type" string "Backburner"
				plug=0
				for it in LPM_NetworkPlugins where it.type==theNetworkType do
					plug=it
				if(plug==0) then
				(
					messagebox ("Could not find network submission plugin:"+theNetworkType)
					return false
				)
				
				result=plug.submit()
				if(result!=#SUCCESS) then
				(
					messagebox result
				)
			)
		)
		else
		(
				if(maxfilepath=="") then
				(
					messagebox "Please save the max file before a net render"
					return false
				)
				
				theNetworkType=LPM_Fun.getIni "Settings" "Network Type" string "Backburner"
				plug=0
				for it in LPM_NetworkPlugins where it.type==theNetworkType do
				plug=it
				if(plug==0) then
				(
					messagebox ("Could not find network submission plugin:"+theNetworkType)
					return false
				)
				
				result=plug.submit()
				if(result!=#SUCCESS) then
				(
					messagebox result
				)
		)
	)
	else
	(
		messageBox ProjRenderPathTest[2]
	)
	
),

/*
mode:#preview, #previewHalf, #local, #backburner, #maxfile, #hwPreview
renderCollect:(#(pass), #(pass,shot))
*/
whoToRender=#(),

fn renderSubmit mode netRenderSettings:undefined=
(
	renderCollect=whoToRender
	
	flag=true
	for i=1 to renderCollect.count where flag do
	(
		LPM_Fun.renderBarProgress=(100*(i-1))/renderCollect.count
			print  mode
			if mode==#hwPreview then
			(
				LPM_hardwareRender renderCollect[i][1] theShot:renderCollect[i][2]
			)
			else
			(
				LPM_renderPass renderCollect[i][1] mode theShot:renderCollect[i][2] netRenderSettings:netRenderSettings
			)
		
		if(keyboard.escPressed) then flag=false
	)
),

fn collectPasses activeOnly:true theShot:undefined=
(
	o=not activeOnly
	renderCollect=#()
	
	for pg in LPM_Root.children where (pg.type=="passGroup" and (pg.active or o)) do
		for thePass in pg.children where  (isvalidnode thePass) and (thePass.type=="pass") and (thePass.active or o)  do append renderCollect #(thePass, theShot)
	for thePass in LPM_Root.children where (thePass.type=="pass") and (thePass.active or o)  do append renderCollect #(thePass, theShot)
	renderCollect
),

fn setWhoToRenderByRenderType=
(
	if ((CheckProjRenderPath())[1]) then
	(
		renderCollect=#()
		shotRoot=(LPM_Fun.firstChildByType LPM_Root "shotRoot")
		
		if(LPM_Root.renderType <=2) then
		(
			renderCollect=collectPasses()
		)
		else
		(
			for theShot in shotRoot.children  where (theShot.type=="shot") and (theShot.active) do
				(
					if(theShot.allpasses) then
					(
						join renderCollect (collectPasses activeOnly:true theShot:theShot)
					)
					else
						for i=1 to theShot.passes.count  where  (isvalidnode theShot.passes[i])  and (theShot.passesOn[i]==true) and (theShot.passes[i].active) do append renderCollect #(theShot.passes[i], theShot)
				)
		)
		LPM_Fun.whoToRender=renderCollect
	)
),

fn getWhoToRender=
(
	return LPM_Fun.whoToRender
),


fn localRenderSubmit=
(
	ProjRenderPathTest = CheckProjRenderPath()
	
	if ProjRenderPathTest[1] then
	(
		ProjRenderPath = getProjRenderPath()
		if ProjRenderPath != LPM_Root.rootDir then
		(
			if (queryBox "Saving directory is not correct. Continue?") then
			(
				if(LPM_Root.renderType==2) or (LPM_Root.renderType==4) then
					renderFlag=#hwPreview
				else
					renderFlag=#local
				
				renderSubmit renderFlag
				
				LPM_Fun.renderBarProgress=undefined
			)
		)
		else
		(
				if(LPM_Root.renderType==2) or (LPM_Root.renderType==4) then
					renderFlag=#hwPreview
				else
					renderFlag=#local
				
				renderSubmit renderFlag
				
				LPM_Fun.renderBarProgress=undefined
		)
	)
	else
	(
		messageBox ProjRenderPathTest[2]
	)
),

--PhotoStudio--------------------------------------------------------------------
-----------------------------------------------------------------------------------
fn createPhotoStudio theName=
(
	prop=LPM_Fun.createNode theName "photoStudio"
	prop.ps=BO_Photostudio()
	prop
),

fn getPreviewFile thePass=
(
	tmpName = ""
	try 
	(
		tmpName = (getDir #preview)+"\\"+maxFileName+"_"+"\\"+(LPM_Fun.getname thePass.name)+"_."+(LPM_Fun.getIni "Settings" "Default Format" string "exr")
	)
	catch
	(
		tmpName = ""
	)
	tmpName
),


fn viewRamPlayer thePath=
(
	try(

		if(thePath!=undefined) then
		(
			fileList= getfiles ((getFilenamePath thePath) + (getFileNameFile thePath) + "*" + (getFileNametype thePath))
			if(fileList.count!= 0) then
			(
				out=createFile ((getdir #preview) + "\\LPM_IFL.ifl")
				if(out!=undefined) then
				(
					for it in fileList do format "%\n" it to:out
					close out
					ramplayer ((getdir #preview) + "\\LPM_IFL.ifl") ""
				)
			)
			else
			(
				throw "Files not found."
			)
		)
	) catch (messagebox (getcurrentexception()) title:"RamPlayer Load")
),

fn quickScripts=
(
	global LPM_QuickScripts
	pathString=getdir #maxroot + "scripts\\LPM\\QuickScripts\\";
	
	--right click menu for passes
	RC="rcMenu LPM_QuickScripts (\n"
	count=0;
	theDirs=getdirectories (pathString+"*")
	--load all the subfolders
	appendLater=""
	tmpSepNumb = 0
	for fit in theDirs do
	(
		subName=(substring fit (pathString.count+1) (fit.count-pathstring.count-1))
			subName = substring subName 3 subName.count
		RC+="subMenu \""+subName +"\"\n"
		RC+="(\n"
		theFiles=getFiles (fit+"*.ms")
		theFiles2=getFiles (fit+"*.mse")
		
		join theFiles theFiles2
		sort theFiles
		
		
		
		for it in theFiles do
		(
			tmpSepNumb += 1
		
			if ((findString (getFileNameFile it) "seperator" ) == undefined) then
			(
				RC+="menuItem "+("a"+count as string)  +" \"" +(substring (getFileNameFile it) 3 (getFileNameFile it).count) +"\";\n"
				appendLater+="on "+("a"+count as string)  + " picked do try(filein @\""+ it +"\")catch(Messagebox \"Error Loading Script\");\n"
				count+=1;
			)
			else
			(
				RC+="seperator "+ "seper_100" + (tmpSepNumb as string) + "\n"
			)
		)
		RC+=")\n"
	)
	
	RC+=appendLater
	theFiles=getFiles (pathString+"*.ms")
	theFiles2=getFiles (pathString+"*.mse")
		
	join theFiles theFiles2
	sort theFiles
	
	--tmpSepNumb = 0
	
	for it in theFiles do
	(
		tmpSepNumb += 1
		
		if ((findString (getFileNameFile it) "seperator" ) == undefined) then
		(
			RC+="menuItem "+("a"+count as string)  +" \"" +(substring (getFileNameFile it) 3 (getFileNameFile it).count) +"\";\n"
			RC+="on "+("a"+count as string)  + " picked do try(filein @\""+ it +"\")catch(Messagebox \"Error Loading Script\");\n"
			count+=1;
		)
		else
		(
			RC+="seperator "+ "seper_100" + (tmpSepNumb as string) + "\n"
		)
		
	)
	
	RC+="Seperator s1\n"
	RC+="menuItem AddNewScriptsHere \"Add New Scripts here...\";\n"
	RC+="on AddNewScriptsHere picked do shellLaunch @\"" + pathString + "\" \"\";\n"
	RC+=")\n"
	execute RC
	popUpMenu LPM_QuickScripts
),



fn NetworkType=
(
	global LPM_QuickScripts
	pathString=getdir #maxroot + "scripts\\LPM\\QuickScripts\\";
	
	--right click menu for passes
	RC="rcMenu LPM_QuickScripts (\n"
	count=0;
	theDirs=getdirectories (pathString+"*")
	--load all the subfolders
	appendLater=""
	tmpSepNumb = 0

	
	RC+=appendLater
	theFiles=getFiles (pathString+"*.ms")
	theFiles2=getFiles (pathString+"*.mse")
		
	join theFiles theFiles2
	sort theFiles
	
	--tmpSepNumb = 0
	
	theNetworkType=LPM_Fun.getIni "Settings" "Network Type" string "Backburner"
	
	networkTypeList=for n in LPM_NetworkPlugins collect n.type
	
	for it in networkTypeList do
	(
		tmpSepNumb += 1
		
		tmpCurrNetworkType = "false"
		
		if it == theNetworkType then
		(
			tmpCurrNetworkType = "true"
		)
		
		
		
		RC+="menuItem "+("a"+count as string)  +" \"" +(it)  +"\" " + "checked:" + tmpCurrNetworkType + "\n"
		RC+="on "+("a"+count as string)  + " picked do try ( LPM_Fun.setIni \"Settings\" \"Network Type\" \""+ it +"\"\n)catch(Messagebox \"Error Loading Script\");\n"
		count+=1;
		
		
	)
	
	
	RC+=")\n"
	execute RC
	popUpMenu LPM_QuickScripts
),

fn InitListView theListView theColumnName theColumnWidth=
(
	theListView.Columns.Clear()
	theListView.Items.Clear()
	
	theListView.view = (dotNetClass "system.windows.forms.view").Details
	
	--showmethods theListView
	theListView.GridLines = false
	theListView.CheckBoxes = true
	theListView.FullRowSelect = true
	theListView.Sorting = (dotNetClass "System.Windows.Forms.SortOrder").None
	theListView.HideSelection = false
	theListView.AutoArrange = false
	theListView.HeaderStyle = (dotNetClass "System.Windows.Forms.ColumnHeaderStyle").none
	--show theListView.TopItem-- = dotNetObject "System.Windows.Forms.ListViewItem" "gfgf"
	
	theListView.ForeColor = FontColor
	theListView.BackColor = BackColor
	
	theListView.columns.add theColumnName (theColumnWidth - 30)
	
	--theListView.AutoResizeColumn()
),

fn FillListView theListView TmpInputRaws TmpSelectedRaws=
(
	TmpRows = #()
	
	for i = 1 to TmpInputRaws.count do
	(
		theListViewItem = dotNetObject "System.Windows.Forms.ListViewItem" (TmpInputRaws[i])
		theListViewItem.Checked = false
		
		TmpFound = finditem TmpSelectedRaws TmpInputRaws[i]
		
		if(TmpFound !=0) then
		(
			theListViewItem.Checked = true
		)
		
		append TmpRows theListViewItem
	)
	
	theListView.items.addRange TmpRows
	theListView.Update()
),

fn CheckListView theListView TmpSelectedRaws=
(
	TmpCount = TmpSelectedRaws.count  --theListView.items.count as integer
	
	if TmpCount > 0 then
	(
		for i = 1 to TmpCount do 
		(
			theListView.items.item[(TmpSelectedRaws[i])-1].checked = true
		)
	)
	
	theListView.Update()
),

fn SaveListView theListView =
(
	TmpSelectedArr = #()
	
	TmpCount = theListView.items.count as integer
	if TmpCount > 0 then
	(
	for i = 1 to TmpCount do 
		(
			if theListView.items.item[i-1].checked then
			(
				append TmpSelectedArr theListView.items.item[i-1].text
			)
		)
	)
	TmpSelectedArr
),
fn SaveListViewNumbers theListView =
(
	TmpSelectedArr = #()
	
	TmpCount = theListView.items.count as integer
	if TmpCount > 0 then
	(
	for i = 1 to TmpCount do 
		(
			if theListView.items.item[i-1].checked then
			(
				append TmpSelectedArr (i)
			)
		)
	)
	TmpSelectedArr
),
fn UpdateCheck =
(
	
	TmpUpdChk = LPM_Fun.getIni "Settings" "auto_update_check" booleanClass true
	TmpUpdChkDays = LPM_Fun.getIni "Settings" "auto_update_check_days" integer 7
	
	if TmpUpdChk do
	(
		lastCheckTicks =   LPM_Fun.getIni "Settings" "last_update_check" Integer64 0L
		
		if (lastCheckTicks==0L OR lastCheckTicks==undefined) do 
		(
			lastCheckTicks = 0L;
			LPM_Fun.setIni "Settings" "last_update_check" 0L
		)
		
		
		nowTicks = (dotNetClass "System.DateTime").Now.Ticks;
		lastCheckSpan = dotNetObject "System.TimeSpan" (nowTicks - lastCheckTicks);
		
		if  ((lastCheckSpan.totalDays as integer) >= TmpUpdChkDays OR  lastCheckTicks==0L) do
		(
			LPM_Fun.setIni "Settings" "last_update_check" nowTicks
			
			LPM_Fun.UpdateCheckNow()
		)
	)
),
fn UpdateCheckNow =
(
	rollout httpSock "httpSock" width:0 height:0
	(
		activeXControl port "Microsoft.XMLHTTP" setupEvents:false releaseOnClose:false
	);
	createDialog httpSock pos:[-100,-100];
	destroyDialog httpSock;
	print "Prism checking for update.."
	
	httpSock.port.open "GET" ("http://www.grovergol.com/wp-content/uploads/update/check.php?product=Prism&version=" + PrismVersion as string) false;
	httpSock.port.setrequestheader "If-Modified-Since" "Sat, 1 Jan 1900 00:00:00 GMT";
	httpSock.port.send();
	res=httpSock.port.responsetext
	
	
	if (res=="1") then
	(
		v=((PrismVersion/100)/10.0) as string 
		
		
		r=querybox ("Update for Prism is available! Go to download page?")
		if (r==true) do
		(	print "Prism update available"	
			shellLaunch "http://www.grovergol.com/?page_id=338" ""
		)
	) else
	(
		print "Prism is up to date."	
	)
),
fn MakeNodeUnique =
(
	theNode = LPM_treeview_rollout.tv.selectedNode.tag.value
	
	AllNodeChildren = for jt in (LPM_Fun.getAllChildren theNode) collect jt
	InstanceMgr.MakeObjectsUnique AllNodeChildren #individual
	
	LPM_treeview_rollout.updateTV()
)

)

LPM_Fun=(LPM_Fun_Struct())

	
	


fn LPM_renderer_closed = 
( 
	callbacks.RemoveScripts #tabbedDialogDeleted id:#myscript_update
	
	thePass=LPM_activePass
	TheProps = LPM_Fun.firstChildByType thePass "renderProps"
	
	
	try
	(
		TheProps.propsAlternate=LPM_Fun.saveRenderPresetNew()
	)
	catch
	(
		TheProps.props=LPM_Fun.saveRenderPreset()
		Messagebox "Please recreate renderer override"
	)
	
	TheProps.initialized=true
	
	
	
	theRenderer=(classof renderers.current) as string
	theNode=LPM_treeview_rollout.tv.selectedNode
	
	if theNode.tag.value.type == "pass" then
	(
		TmpTmpNode = theNode
		for i = 0 to (theNode.nodes.count - 1) do 
		(
			if theNode.nodes.item[i].tag.value.type == "renderProps" then
			(
				TmpTmpNode = theNode.nodes.item[i]
			)
		)
		
		theNode = TmpTmpNode
	)
	
	if(theNode.text=="Render Override") or (theNode.text=="Scanline") or (theNode.text=="Mental Ray") or (theNode.text=="VRay") or (theNode.text=="Corona") then
	(
		if(findstring theRenderer "Scanline"!=undefined) then
		(	
			theNode.text="Scanline"
			theNode.tag.value.name="LPM_"+"Scanline"
		
		)	
		else if (findstring theRenderer "Mental"!=undefined) then
		(
			theNode.text="Mental Ray"
			theNode.tag.value.name="LPM_"+"Mental Ray"
		)
		else if (findString theRenderer "V_Ray" !=undefined) then
		(
			theNode.text="VRay"
			theNode.tag.value.name="LPM_"+"Vray"
		)
		else if (findString theRenderer "Corona" !=undefined) then
		(
			theNode.text="Corona"
			theNode.tag.value.name="LPM_"+"Corona"
		)
	)
	
	try
	(
		LPM_Fun.loadRenderPresetNew LPM_oldRenderSettingsNew
	)
	catch
	(
		LPM_Fun.loadRenderPreset LPM_oldRenderSettings
	)
	LPM_treeview_rollout.UnFreezeWindow()
)



fn LPM_ProSequencerUpdate = 
(
	
	try
	(
		shotRoot=LPM_Fun.firstChildByType LPM_Root "shotRoot"
		
		if shotRoot != undefined then
		(
			ProSequencerData=ProSequencer.getSequenceData()
			
			TmpShots = for CurShot in shotRoot.children where CurShot.type=="shot" collect CurShot
			
			for tmptrack in ProSequencerData do
			(
				if (isvalidnode tmptrack.cam) then
				(
					CurShotFound = 0
					
					for CurShot in TmpShots do
					(
						theCp=LPM_Fun.firstChildByType CurShot "commonProps"
						
						if theCp != undefined then
						(
							if (isvalidnode theCp._Camera) then
							(
								if (tmptrack.cam == theCp._Camera) then
								(
									CurShot.active = tmptrack.enabled
									theCp.timeOutputTgl = true
									theCp._rendTimeType = 3
									theCp._rendStart = tmptrack.clipStart
									theCp._rendEnd = tmptrack.clipEnd - (1 as time)
									
									CurShotFound = true
								)
								else
								(
									if CurShotFound == 0 then
									(
										CurShotFound = false
									)
								)
							) 
							
						)
					)
					
					if not CurShotFound then
					(
						theShot = LPM_Fun.createShot LPM_Root
						theShot.name = "LPM_" + tmptrack.cam.name
						theShot.active = tmptrack.enabled
						
						theCp2=LPM_Fun.firstChildByType theShot "commonProps"
						
						theCp2.cameraTgl = true
						theCp2._camera = tmptrack.cam
						
						theCp2.timeOutputTgl = true
						theCp2._rendTimeType = 3
						theCp2._rendStart = tmptrack.clipStart
						theCp2._rendEnd = tmptrack.clipEnd - 1
					)
				)
				
			)
			
		)
		
		
		LPM_treeview_rollout.updateTV()
	)
	catch
	(
		
	)
	
	
)

fn  LPM_ProSequencerImport =
(
	try
	(
		ProSequencerData=ProSequencer.getSequenceData()
		
		tmpArr = for tmptrack in ProSequencerData collect tmptrack
		
		
		for i=1 to tmpArr.count do
		(
			tmptrack = tmpArr[tmpArr.count - i + 1]
			
			if(isvalidnode tmptrack.cam) then
			(
				theShot = LPM_Fun.createShot LPM_Root
				theShot.name = "LPM_" + tmptrack.cam.name
				theShot.active = tmptrack.enabled
				
				theCp=LPM_Fun.firstChildByType theShot "commonProps"
				
				theCp.cameraTgl = true
				theCp._camera = tmptrack.cam
				
				theCp.timeOutputTgl = true
				theCp._rendTimeType = 3
				theCp._rendStart = tmptrack.clipStart
				theCp._rendEnd = tmptrack.clipEnd - 1
			)
		)
		
		
		LPM_treeview_rollout.updateTV()
	)
	catch
	(
		print "Error importing ProSequencer data."
	)
)

fn  LPM_ProSequencerSync =
(
	try
	(
		
		if LPM_syncPS then
		(
			LPM_ProSequencerUpdate()
		)
		
	)
	catch()
)

fn  LPM_ProSequencerPlay =
(
	try
	(
		if LPM_syncPS then
		(
			LPM_treeview_rollout.hideByProSequencer()
		)
	)
	catch()
)

fn CheckIsAllLayerObjects =
(

	IsAllLayerObjects = false
	TmpLayersArr = #()
	TmpLayersObjArr = #()
	
	OutLayersArr = #()

	if selection[1] != undefined then
	(
		
		
		
		
		tmpSelArr = selection as array
		
		
		for obj in tmpSelArr do 
		(
			tmpLayer = obj.layer
			tmpLayerName = tmpLayer.name
			LayerNumb = findItem TmpLayersArr tmpLayerName
			
			if LayerNumb > 0 then
			(
				append TmpLayersObjArr[LayerNumb] obj
			)
			else
			(
				append TmpLayersArr tmpLayerName
				TmpLayersObjArr[TmpLayersObjArr.count+1] = #(obj)
			)
			
		)
		
		IsAllLayerObjectsFirstFlag = true
		
		for i=1 to TmpLayersArr.count do 
		(
			
			tmpLayer = LayerManager.getLayerFromName TmpLayersArr[i]
			
			tmpLayer.nodes &TmpNodes
			TmpNodes = TmpNodes  as array
			TmpNodesCount = TmpNodes.count
			
			TmpLayersObjArrCount = TmpLayersObjArr[i].count
			
			if (TmpLayersObjArrCount == TmpNodesCount)and(IsAllLayerObjectsFirstFlag) then
			(
				if(TmpLayersArr[i]!="zz-LPM") then
				(
					IsAllLayerObjects = true
					
					append OutLayersArr TmpLayersArr[i]
				)
			)
			else
			(
				IsAllLayerObjects =IsAllLayerObjectsFirstFlag= false
			)
		)
	
	)
	#(IsAllLayerObjects,OutLayersArr)
)


Struct LPM_ObjSetProps (intP,pMatEnable,pMaterial,expanded,pColor,visible,selectable,userProp)

Struct LPM_LightSetProps (pEnable,pMultiplierEnable,pMultiplier,pColorEnable,pColor,pCastShadows,pAffectDiffuse,pAffectSpecular,pAffectReflections,pTextureEnable,pTexture,expanded)

LPM_ObjSetPropsBuff = LPM_ObjSetProps()
LPM_LightSetPropsBuff = LPM_LightSetProps()