



----------------------------------- GLOBALS --------------------------

shotRoot = LPM_Fun.firstChildByType LPM_Root "shotRoot"
thePasses = #()
thePassesNames = #()
theShots = #()
theShotsNames = #()

fn PrismSavePresetInit =
(
	thePasses = for TmpChild in (LPM_Fun.getAllChildren LPM_Root) where (TmpChild.type == "pass") collect TmpChild
	theShots = for TmpChild in (LPM_Fun.getAllChildren LPM_Root) where (TmpChild.type == "shot") collect TmpChild
	
	thePassesNames = for i in thePasses collect LPM_Fun.generatePassName i
	theShotsNames = for i in theShots collect LPM_Fun.getname i.name
	
	LPM_treeview_rollout.FreezeWindow()
)

----------------------------------- MAIN ROLLUUT --------------------------

rollout PrismSavePreset "Prism Save Preset" width:545 height:400
(
	GroupBox grpSelectPasses "Select Passes" pos:[5,5] width:265 height:350 align:#left
	dotNetControl LB_Passes "system.windows.forms.listView" pos:[10,22] width:255 height:325 align:#left
	GroupBox grpSelectShots "Select Shots" pos:[275,5] width:265 height:350 align:#left
	dotNetControl LB_Shots "system.windows.forms.listView" pos:[280,22] width:255 height:325 align:#left
	button btn_Save "Save" pos:[5,360] width:535 height:35 align:#left
	
	on PrismSavePreset open do
	(
		PrismSavePresetInit()
		
		LPM_Fun.InitListView LB_Passes "Select Passes" 255
		LPM_Fun.FillListView LB_Passes thePassesNames #()
		
		LPM_Fun.InitListView LB_Shots "Select Shots" 255
		LPM_Fun.FillListView LB_Shots theShotsNames #()
	)
	
	on PrismSavePreset close do
	(
		LPM_treeview_rollout.UnFreezeWindow()
	)
	
	on btn_Save pressed do
	(
		TmpSaveMainNodes = #()
		TmpSaveNodes = #()
		PassesToSave = #()
		ShotsToSave = #()
		
		SelectedPassesNumbers = LPM_Fun.SaveListViewNumbers LB_Passes
		SelectedShotsNumbers = LPM_Fun.SaveListViewNumbers LB_Shots
		
		PassesToSave = for i = 1 to thePasses.count where ((finditem SelectedPassesNumbers i)!=0) collect thePasses[i]
		ShotsToSave = for i = 1 to theShots.count where ((finditem SelectedShotsNumbers i)!=0) collect theShots[i]
		
		TmpSaveMainNodes = join PassesToSave ShotsToSave
		
		
		for TmpNode in TmpSaveMainNodes do
		(
			join TmpSaveNodes (LPM_Fun.getAllChildren TmpNode)
		)
		
		TmpfilePath=getSaveFileName caption:"Save LPM preset file" fileName:(maxfilepath) types:"Max files(*.lpmpr)|*.lpmpr"
		
		if(TmpfilePath!=undefined) then
		(
			savenodes TmpSaveNodes TmpfilePath
			destroyDialog PrismSavePreset
		)
		
	)
)

createdialog PrismSavePreset pos:(LPM_Fun.getRoPos  PrismSavePreset.width)