
----------------------------------- GLOBALS --------------------------
shotRoot = LPM_Fun.firstChildByType LPM_Root "shotRoot"
AllOldPasses = for TmpChild in (LPM_Fun.getAllChildren LPM_Root) where (TmpChild.type == "pass") collect TmpChild
AllOldPassesNames = for TmpChild in AllOldPasses collect (LPM_Fun.generatePassName TmpChild)

validNodes = #()
newNodes = #()
theNewPasses = #()
theNewPassesNames = #()
theNewShots = #()
theNewShotsNames = #()
MergeBtnPressed = false
NotAllPasses = false
NotAllPassesNames = ""
PossiblePassesRelinked = false
RelinkedPassesNames = ""

oldCount=$objects.count

filePathtemp = getOpenFileName caption:"Pick the max file containing the preset" fileName:maxfilepath types:"Max files(*.max)|*.max|LPM preset files(*.lpmpr)|*.lpmpr"

----------------------------------- INIT --------------------------

fn PrismMergePresetInit =
(
	if filePathtemp != undefined  then
	(
		MergedLPMobjects=#()
		MergedAllObjects=getMAXFileObjectNames filePathtemp
		bol = ((getNodeByName "la4la")==undefined)
		
		for cur in MergedAllObjects do	if (((substring cur 1 3)=="LPM") and (cur!="LPM_Root")  and (cur!="shotRoot") or cur=="la4la") then 
		(
			append MergedLPMobjects cur
		)
		
		for cur in MergedAllObjects do if ((substring cur 1 6)=="Common") then
		(
			append MergedLPMobjects cur
		)
		
		
		----------------------------------- MERGE FILE --------------------------
		
		mergeMAXFile filePathtemp MergedLPMobjects #mergeDups #useSceneMtlDups #neverReparent
		
		
		
		for i=oldCount+1 to $objects.count do append newNodes $objects[i]
		
		
		for curNode in newNodes do 
		(
			if(isProperty curNode #type) and (curNode.type=="pass") then
			(
				curNode.parent = LPM_Root
			)
			
			if(isProperty curNode #type) and (curNode.type=="shot") then
			(
				curNode.parent = shotRoot
			)
			
			if (curNode!=undefined) and  ((substring curNode.name 1 5)=="la4la") then 
			(
				if bol != true then
				(
					LPM_Fun_Struct.mergeLa4la curNode
				)
			)
		)
		
		for i in newNodes do
		(
			if ((substring i.name 1 6)=="Common") and (not (isProperty i "_rendTimeType")) and (IsValidNode i) then
			(
				delete i
			)
		)
		
		for i in newNodes do
		(
			if ((IsValidNode i) and (i.parent==undefined)) then delete i
		)
		
		validNodes = for i in newNodes where (IsValidNode i) collect i
		
		
		theNewPasses = for i in validNodes where i.type=="pass" collect i
		theNewShots = for i in validNodes where i.type=="shot" collect i
		
		theNewPassesNames = for i in theNewPasses collect LPM_Fun.generatePassName i
		theNewShotsNames = for i in theNewShots collect LPM_Fun.getname i.name
		
		LPM_treeview_rollout.FreezeWindow()
	)
)

----------------------------------- MAIN ROLLUUT --------------------------

rollout PrismMergePreset "Prism Merge Preset" width:545 height:400
(
	GroupBox grpSelectPasses "Select Passes" pos:[5,5] width:265 height:350 align:#left
	dotNetControl LB_Passes "system.windows.forms.listView" pos:[10,22] width:255 height:325 align:#left
	GroupBox grpSelectShots "Select Shots" pos:[275,5] width:265 height:350 align:#left
	dotNetControl LB_Shots "system.windows.forms.listView" pos:[280,22] width:255 height:325 align:#left
	button btn_Merge "Merge" pos:[5,360] width:535 height:35 align:#left
	
	on PrismMergePreset open do
	(
		PrismMergePresetInit()
		
		LPM_Fun.InitListView LB_Passes "Select Passes" 255
		LPM_Fun.FillListView LB_Passes theNewPassesNames #()
		
		LPM_Fun.InitListView LB_Shots "Select Shots" 255
		LPM_Fun.FillListView LB_Shots theNewShotsNames #()
	)
	
	on PrismMergePreset close do
	(
		if not MergeBtnPressed then
		(
			delete validNodes
		)
		LPM_treeview_rollout.UnFreezeWindow()
	)
	
	on btn_Merge pressed do
	(
		PassesToDelete = #()
		ShotsToDelete = #()
		
		SelectedPassesNumbers = LPM_Fun.SaveListViewNumbers LB_Passes
		SelectedShotsNumbers = LPM_Fun.SaveListViewNumbers LB_Shots
		
		PassesToDelete = for i = 1 to theNewPasses.count where ((finditem SelectedPassesNumbers i)==0) collect theNewPasses[i]
		ShotsToDelete = for i = 1 to theNewShots.count where ((finditem SelectedShotsNumbers i)==0) collect theNewShots[i]
		
		PassesToKeep = for i = 1 to theNewPasses.count where ((finditem SelectedPassesNumbers i)!=0) collect theNewPasses[i]
		ShotsToKeep = for i = 1 to theNewShots.count where ((finditem SelectedShotsNumbers i)!=0) collect theNewShots[i]
		
		for TmpShot in ShotsToKeep do
		(
			if (not TmpShot.allPasses) then
			(
				for i = 1 to TmpShot.passes.count do
				(
					TmpShotPass = TmpShot.passes[i]
					
					if ((finditem PassesToKeep TmpShotPass)==0) then
					(
						PossiblePassNumb = finditem AllOldPassesNames (LPM_Fun.generatePassName TmpShotPass)
						
						if PossiblePassNumb != 0 then
						(
							PossiblePass = AllOldPasses[PossiblePassNumb]
							TmpShot.passes[i] = PossiblePass
							PossiblePassesRelinked = true
							RelinkedPassesNames += " - " + ( LPM_Fun.getname TmpShot.name) + " :  " + (LPM_Fun.generatePassName TmpShotPass) + "\n"
						)
						else
						(
							NotAllPasses = true
							NotAllPassesNames += " - " + ( LPM_Fun.getname TmpShot.name) + " :  " + (LPM_Fun.generatePassName TmpShotPass) + "\n"
						)
					)
				)
				
			)
		)
		
		for TmpPass in PassesToDelete do
		(
			for TmpChild in (LPM_Fun.getAllChildren TmpPass) do delete TmpChild
		)
		
		for TmpShot in ShotsToDelete do
		(
			for TmpChild in (LPM_Fun.getAllChildren TmpShot) do delete TmpChild
		)
		
		filein (LPM_Dir + "CA.ms")
		
		LPM_treeview_rollout.updateTV()
		
		try
		(
			LPM_Fun.FixOldRenderPresetStyle()
		)
		catch()
		
		MergeBtnPressed = true
		destroyDialog PrismMergePreset
		
		
		if PossiblePassesRelinked then
		(
			messagebox ("Not all shot passes were merged!\n" + NotAllPassesNames + "Some were replaced with current scene passes with the same names.\n" + RelinkedPassesNames)
		)
		else if NotAllPasses then
		(
			messagebox ("Shot passes were not merged!\n" + NotAllPassesNames)
		)
	)
)

if filePathtemp != undefined  then
(
	createdialog PrismMergePreset  pos:(LPM_Fun.getRoPos  PrismMergePreset.width)
)

