/*
Deadline job submission written by Jacob Jeziorski (www.JakubJeziorski.com)
for Lukas Lepicovsky's LPass Manager
www.lukashi.com
*/

fnScript = "S:\\DeadlineRepository\\submission\\3dsmax\\Main\\SubmitMaxToDeadline_Functions.ms" ----- Replace this path with yours

LpmSettingsFile = ( getdir #plugcfg + "\\LPM.ini" )
if doesFileExist LpmSettingsFile then
(
	try
	(
		fnScript = getINISetting LpmSettingsFile "Deadline_Options" "Deadline_Server"
	)
	catch()
)
else
(
	setINISetting LpmSettingsFile "Deadline_Options" "Deadline_Server" fnScript
)


global SMTDSettings, SMTDFunctions

struct LPM_DeadlineAPI
(
	type="Deadline",
	fn submit=
	(
		rollout LPM_DeadlineSubmitRo "Deadline" width:315 height:480
		(

			
			GroupBox grp_pool "Pool and Priority" pos:[6,8] width:304 height:70
			label lbl_pool "Pool:" pos:[12,32] width:24 height:13
			dropdownList ddl_pool "" pos:[56,28] width:140 height:21
			label lbl_priority "Priority:" pos:[12,54] width:34 height:13
			progressBar sld_priority "" pos:[56,52] width:188 height:18 range:[0,100,50] type:#integer
			spinner spn_priority "" pos:[254,52] width:47 height:16 type:#integer fieldwidth:35

						
			GroupBox grp_job "Job Options" pos:[6,80] width:304 height:216
			label lbl_chunk "Render Task Chunk Size (Frames Per Task):" pos:[12,100] width:211 height:13
			spinner spn_chunkSize "" pos:[254,100] width:47 height:16 range:[1,1000,1] type:#integer fieldwidth:35

						
			checkbox chk_limitEnabled "Limit No. of Machines Rendering Concurrently  " pos:[12,120] width:246 height:15
			spinner spn_machineLimit "" pos:[254,120] width:47 height:16 enabled:false range:[1,1000,1] type:#integer fieldwidth:35

						
			dropdownList ddl_OutOfOrderMethod "" pos:[12,140] width:200 height:21 items:#("First To Last (Forward)", "Every Nth, Then Forward", "Every Nth - Block Fill", "Every Nth - Half Raster Refine", "Last To First (Reverse)", "From Both Ends", "From Center", "From Both Ends And From Center", "Random")
			spinner spn_outOfOrderStep "Nth:" pos:[234,142] width:67 height:16 range:[2,1000,10] type:#integer fieldwidth:35

						
			checkbox chk_EnforceSequentialRendering "Enforce Sequential Rendering" pos:[12,165] width:166 height:15
			checkbox chk_rebuildElements "Rebuild Elements" pos:[12,238] width:122 height:15


			checkbox chk_submitAsSuspended "Submit Job As Suspended" pos:[12,259] width:148 height:15
			checkbox chk_autodelete "Delete Complete Job" pos:[12,276] width:122 height:15


			label lbl_MaxVersionToForce "Force 3ds Max Build:" pos:[202,241] width:99 height:13
			dropdownList ddl_MaxVersionToForce "" pos:[200,259] width:102 height:21 items:#("none", "32bit", "64bit")

			GroupBox grp_options "Options" pos:[6,344] width:304 height:100
			checkbox chk_Viewboundbox "Viewport bounding box mode" pos:[12,379] width:190 height:15 toolTip:"Turns viewport display mode to bounding box"
			checkbox chk_showvfb "Show VFB" pos:[12,361] width:74 height:15
			dropdownList ddl_SubmitExternalFilesMode "" pos:[12,399] width:291 height:21 items:#("Do NOT copy Textures to Repository", "Copy LOCAL Textures to Repository", "Copy ALL Textures to Repository")
			checkbox chk_RegionRender "Enable Region Rendering" pos:[12,425] width:140 height:15 tooltip: ""


			progressBar prg_submitProgress "" pos:[6,449] width:150 height:27
						
			checkbox chkIgnoreFiles "Ignore Missing External Files" pos:[12,201] width:166 height:15

			checkbox chkIgnoreDLL "Ignore Missing DLL" pos:[12,217] width:166 height:15
			GroupBox grp_Naming "Naming" pos:[6,297] width:303 height:46
			edittext edt_prefix "Prefix" pos:[15,315] width:130 height:17
			edittext edt_suffix "Suffix" pos:[167,315] width:130 height:17
					
						
			button btn_sanityCheck "Sanity Check" pos:[160,449] width:75 height:27
			button btn_submit "Submit" pos:[235,449] width:75 height:27
					
			
			
			
			
			fn loadSettings =
			(
				--store settings as last settings
				
				SMTDSettings.PoolName = LPM_Fun.GetIni "Deadline Settings" "PoolName" string "3dsmax"
				SMTDSettings.Priority = LPM_Fun.GetIni "Deadline Settings" "Priority" integer 50
				SMTDSettings.ChunkSize = LPM_Fun.GetIni "Deadline Settings" "ChunkSize" integer 1
				SMTDSettings.LimitEnabled = LPM_Fun.GetIni "Deadline Settings" "LimitEnabled" booleanClass false
				SMTDSettings.machineLimit = LPM_Fun.GetIni "Deadline Settings" "machineLimit" integer 0
				
				SMTDSettings.OutOfOrderMethod = LPM_Fun.GetIni "Deadline Settings" "OutOfOrderMethod" string #normal
				SMTDSettings.OutOfOrderStep = LPM_Fun.GetIni "Deadline Settings" "OutOfOrderStep" integer 1
				SMTDSettings.SequentialJob = LPM_Fun.GetIni "Deadline Settings" "SequentialJob" booleanClass false
				SMTDSettings.SubmitAsSuspended = LPM_Fun.GetIni "Deadline Settings" "SubmitAsSuspended" booleanClass false
				SMTDSettings.AutoDelete = LPM_Fun.GetIni "Deadline Settings" "AutoDelete" booleanClass false
				SMTDSettings.MaxVersionToForce = LPM_Fun.GetIni "Deadline Settings" "MaxVersionToForce" string "none"
				SMTDSettings.SubmitExternalFilesMode = LPM_Fun.GetIni "Deadline Settings" "SubmitExternalFilesMode" integer 1
				SMTDSettings.ShowFrameBuffer = LPM_Fun.GetIni "Deadline Settings" "ShowFrameBuffer" booleanClass true
				SMTDSettings.IgnoreMissingExternalFiles = LPM_Fun.GetIni "Deadline Settings" "IgnoreMissingExternalFiles" booleanClass true
				SMTDSettings.IgnoreMissingDLLs = LPM_Fun.GetIni "Deadline Settings" "IgnoreMissingDLLs" booleanClass false
				try 
				(
					SMTDSettings.RebuildRenderElements = LPM_Fun.GetIni "Deadline Settings" "RebuildRenderElements" booleanClass true
					SMTDSettings.RegionRendering = LPM_Fun.GetIni "Deadline Settings" "RegionRendering" booleanClass false
				)
				catch
				(
				)
				
				try 
				(
					chk_Viewboundbox.state = LPM_Fun.GetIni "Deadline Settings" "Viewboundbox" booleanClass true
				)
				catch
				(
				)
				--set controls to loaded state
				
				if (isValidNode $LPM_Deadline_Settings) then
				(
					localSettings = $LPM_Deadline_Settings
					SMTDSettings.PoolName = LPM_Fun.getProp localSettings "PoolName" string SMTDSettings.PoolName
					SMTDSettings.Priority = LPM_Fun.getProp localSettings "Priority" integer SMTDSettings.Priority
					SMTDSettings.ChunkSize = LPM_Fun.getProp localSettings "ChunkSize" integer SMTDSettings.ChunkSize
					SMTDSettings.LimitEnabled = LPM_Fun.getProp localSettings "LimitEnabled" booleanClass SMTDSettings.LimitEnabled
					SMTDSettings.machineLimit = LPM_Fun.getProp localSettings "machineLimit" integer SMTDSettings.machineLimit
					SMTDSettings.OutOfOrderMethod = LPM_Fun.getProp localSettings "OutOfOrderMethod" string SMTDSettings.OutOfOrderMethod
					SMTDSettings.OutOfOrderStep = LPM_Fun.getProp localSettings "OutOfOrderStep" integer SMTDSettings.OutOfOrderStep
					SMTDSettings.SequentialJob = LPM_Fun.getProp localSettings "SequentialJob" booleanClass SMTDSettings.SequentialJob
					SMTDSettings.SubmitAsSuspended = LPM_Fun.getProp localSettings "SubmitAsSuspended" booleanClass SMTDSettings.SubmitAsSuspended
					SMTDSettings.AutoDelete = LPM_Fun.getProp localSettings "AutoDelete" booleanClass SMTDSettings.AutoDelete
					SMTDSettings.MaxVersionToForce = LPM_Fun.getProp localSettings "MaxVersionToForce" string SMTDSettings.MaxVersionToForce
					SMTDSettings.SubmitExternalFilesMode = LPM_Fun.getProp localSettings "SubmitExternalFilesMode" integer SMTDSettings.SubmitExternalFilesMode
					SMTDSettings.ShowFrameBuffer = LPM_Fun.getProp localSettings "ShowFrameBuffer" booleanClass SMTDSettings.ShowFrameBuffer
					
					
					try 
					(
						SMTDSettings.RebuildRenderElements = LPM_Fun.getProp localSettings "RebuildRenderElements" booleanClass SMTDSettings.RebuildRenderElements
						SMTDSettings.IgnoreMissingExternalFiles = LPM_Fun.getProp localSettings "IgnoreMissingExternalFiles" booleanClass SMTDSettings.IgnoreMissingExternalFiles
						SMTDSettings.IgnoreMissingDLLs = LPM_Fun.getProp localSettings "IgnoreMissingDLLs" booleanClass SMTDSettings.IgnoreMissingDLLs
						SMTDSettings.RegionRendering = LPM_Fun.getProp localSettings "RegionRendering" booleanClass SMTDSettings.RegionRendering
					)
					catch
					(
					)
					
					try 
					(
						chk_Viewboundbox.state = LPM_Fun.getProp localSettings "Viewboundbox" booleanClass chk_Viewboundbox.state
					)
					catch
					(
					)
				)
				
				spn_chunkSize.value = SMTDSettings.ChunkSize
				chk_limitEnabled.state = spn_machineLimit.enabled = SMTDSettings.LimitEnabled
				spn_machineLimit.value = SMTDSettings.machineLimit
				local theVal = findItem #(#normal, #nth, #NthBlock, #NthRasterRefine, #reverse, #fromBothEnds, #FromCenter, #fromBothEndsAndCenter, #random) SMTDSettings.OutOfOrderMethod 
				if theVal == 0 do theVal = 1
				ddl_outOfOrderMethod.selection = theVal
				chk_submitAsSuspended.state = SMTDSettings.SubmitAsSuspended 
				chk_autoDelete.state = SMTDSettings.AutoDelete 
				spn_outOfOrderStep.value = SMTDSettings.OutOfOrderStep
				chk_EnforceSequentialRendering.state = SMTDSettings.SequentialJob
				theVal = findItem #("none", "32bit", "64bit") SMTDSettings.MaxVersionToForce 
				if theVal == 0 do versionVal = 1
				ddl_MaxVersionToForce.selection = theVal
				ddl_SubmitExternalFilesMode.selection = 	SMTDSettings.SubmitExternalFilesMode 
				chk_showvfb.state = SMTDSettings.ShowFrameBuffer
				
				chk_rebuildElements.state = SMTDSettings.RebuildRenderElements
				chkIgnoreFiles.state = SMTDSettings.IgnoreMissingExternalFiles
				chkIgnoreDLL.state = SMTDSettings.IgnoreMissingDLLs
				chk_RegionRender.state = SMTDSettings.RegionRendering
				
				
			)


			fn saveSettings =
			(
				--store settings as last settings
				LPM_Fun.SetIni "Deadline Settings" "PoolName" SMTDSettings.PoolName
				LPM_Fun.SetIni "Deadline Settings" "Priority" SMTDSettings.Priority
				LPM_Fun.SetIni "Deadline Settings" "ChunkSize" SMTDSettings.ChunkSize
				LPM_Fun.SetIni "Deadline Settings" "LimitEnabled" SMTDSettings.LimitEnabled
				LPM_Fun.SetIni "Deadline Settings" "machineLimit" SMTDSettings.machineLimit
				LPM_Fun.SetIni "Deadline Settings" "OutOfOrderMethod" SMTDSettings.OutOfOrderMethod
				LPM_Fun.SetIni "Deadline Settings" "OutOfOrderStep" SMTDSettings.OutOfOrderStep
				LPM_Fun.SetIni "Deadline Settings" "SequentialJob" SMTDSettings.SequentialJob
				LPM_Fun.SetIni "Deadline Settings" "SubmitAsSuspended" SMTDSettings.SubmitAsSuspended
				LPM_Fun.SetIni "Deadline Settings" "AutoDelete" SMTDSettings.AutoDelete
				LPM_Fun.SetIni "Deadline Settings" "MaxVersionToForce" SMTDSettings.MaxVersionToForce
				LPM_Fun.SetIni "Deadline Settings" "SubmitExternalFilesMode" SMTDSettings.SubmitExternalFilesMode
				LPM_Fun.SetIni "Deadline Settings" "ShowFrameBuffer" SMTDSettings.ShowFrameBuffer
				
				LPM_Fun.SetIni "Deadline Settings" "RebuildRenderElements" SMTDSettings.RebuildRenderElements
				
				LPM_Fun.SetIni "Deadline Settings" "IgnoreMissingExternalFiles" SMTDSettings.IgnoreMissingExternalFiles
				LPM_Fun.SetIni "Deadline Settings" "IgnoreMissingDLLs" SMTDSettings.IgnoreMissingDLLs
				
				LPM_Fun.SetIni "Deadline Settings" "Viewboundbox" chk_Viewboundbox.state
				LPM_Fun.SetIni "Deadline Settings" "RegionRendering" chk_RegionRender.state
				
				--store settings in scene
				
				if (isValidNode $LPM_Deadline_Settings) then 
					localSettings = $LPM_Deadline_Settings
				else
				(
					localSettings = LPM_Fun.createNode "Deadline_Settings" "empty"
					localSettings.parent = $LPM_Root
				)
				LPM_Fun.setProp localSettings "PoolName" SMTDSettings.PoolName
				LPM_Fun.setProp localSettings "Priority" SMTDSettings.Priority
				LPM_Fun.setProp localSettings "ChunkSize" SMTDSettings.ChunkSize
				LPM_Fun.setProp localSettings "LimitEnabled" SMTDSettings.LimitEnabled
				LPM_Fun.setProp localSettings "machineLimit" SMTDSettings.machineLimit
				LPM_Fun.setProp localSettings "OutOfOrderMethod" SMTDSettings.OutOfOrderMethod
				LPM_Fun.setProp localSettings "OutOfOrderStep" SMTDSettings.OutOfOrderStep
				LPM_Fun.setProp localSettings "SequentialJob" SMTDSettings.SequentialJob
				LPM_Fun.setProp localSettings "SubmitAsSuspended" SMTDSettings.SubmitAsSuspended
				LPM_Fun.setProp localSettings "AutoDelete" SMTDSettings.AutoDelete
				LPM_Fun.setProp localSettings "MaxVersionToForce" SMTDSettings.MaxVersionToForce
				LPM_Fun.setProp localSettings "SubmitExternalFilesMode" SMTDSettings.SubmitExternalFilesMode
				LPM_Fun.setProp localSettings "ShowFrameBuffer" SMTDSettings.ShowFrameBuffer
				LPM_Fun.setProp localSettings "RebuildRenderElements" SMTDSettings.RebuildRenderElements
				
				LPM_Fun.setProp localSettings "IgnoreMissingExternalFiles" SMTDSettings.IgnoreMissingExternalFiles
				LPM_Fun.setProp localSettings "IgnoreMissingDLLs" SMTDSettings.IgnoreMissingDLLs
				
				
				LPM_Fun.setProp localSettings "Viewboundbox" chk_Viewboundbox.state
				LPM_Fun.setProp localSettings "RegionRendering" chk_RegionRender.state
			)
			
			-- FUNCTIONS from SubmitMaxToDeadline --
			fn job_priority_update val =
			(
				if val <= 100 do
				(
					theRed = (255.0 - 255.0*val/100.0)*2.0
					if theRed > 255 do theRed = 255
					theGreen = 512.0*val/100.0
					if theGreen > 255 do theGreen = 255
					sld_priority.color = [theRed, theGreen, 0]
					sld_priority.value = spn_priority.value = val
				)
				val
			)	

			fn displayPoolsList =
			(
				if SMTDSettings.PoolsSort then
				(
					local tempArray = for i in SMTDSettings.Pools collect i
					ddl_pool.items = sort tempArray 
				)	
				else
				(
					ddl_pool.items = SMTDSettings.Pools
				)
				local theIndex = findItem ddl_pool.items SMTDSettings.PoolName
				btn_submit.enabled = true
				if theIndex > 0 then 
					ddl_pool.selection = theIndex 
				else	
					ddl_pool.selection = 1
				
			)

			--EVENT HANDLERS--
			
			on ddl_pool selected itm do 
			(
				SMTDSettings.PoolName = ddl_pool.selected
				displayPoolsList()
			)

			on sld_priority clicked value do
			(
				SMTDSettings.Priority= (job_priority_update value)
			)
			
			on spn_priority changed value do
			(	
				SMTDSettings.Priority= (job_priority_update value)
			)

			on spn_chunkSize changed value do 
			(
				SMTDSettings.ChunkSize = value
			)	

			on chk_limitEnabled changed state do 
			(
				SMTDSettings.LimitEnabled = state
				spn_machineLimit.enabled = state 
			)	
			
			on spn_machineLimit changed value do 
			(
				SMTDSettings.machineLimit = value
			)	

			on ddl_outOfOrderMethod selected itm do
			(
				theMethod= case itm of
				(
						1: #normal
						2: #nth
						3: #NthBlock
						4: #NthRasterRefine
						5: #reverse
						6: #fromBothEnds
						7: #fromCenter
						8: #fromBothEndsAndCenter
						9: #random
				)
				SMTDSettings.OutOfOrderMethod = theMethod
				spn_outOfOrderStep.enabled = itm >= 2 AND itm <= 4
			)

			on spn_outOfOrderStep changed value do 
			(
				SMTDSettings.OutOfOrderStep = value
			)	
				
			on chk_EnforceSequentialRendering changed state do 
			(
				SMTDSettings.SequentialJob = state
			)		
				
			on chk_submitAsSuspended changed state do 
			(
				SMTDSettings.SubmitAsSuspended = state
			)	

			on chk_autoDelete changed state do 
			(
				SMTDSettings.AutoDelete = state
			)	
			
			
			
			
			on chk_rebuildElements changed state do 
			(
				SMTDSettings.RebuildRenderElements = state
			)	
			
			on chkIgnoreFiles changed state do 
			(
				SMTDSettings.IgnoreMissingExternalFiles = state
			)	
			
			on chkIgnoreDLL changed state do 
			(
				SMTDSettings.IgnoreMissingDLLs = state
			)	
			
			on chk_RegionRender changed state do 
			(
				SMTDSettings.RegionRendering = SMTDSettings.RegionUseMaxValues = state
			)	
			
			
			
			on ddl_MaxVersionToForce selected itm do
			(
				case itm of
				(
					1: SMTDSettings.MaxVersionToForce = "none"
					2: SMTDSettings.MaxVersionToForce = "32bit"
					3: SMTDSettings.MaxVersionToForce = "64bit"
				)
			)
			
			on ddl_SubmitExternalFilesMode selected itm do
			(
				SMTDSettings.SubmitExternalFilesMode = ddl_SubmitExternalFilesMode.selection
			)
			
			on chk_showvfb changed state do 
			(
				SMTDSettings.ShowFrameBuffer = state
			)	
			
			on LPM_DeadlineSubmitRo open do
			(
				loadSettings()
				if SMTDSettings.Pools.count == 0 do SMTDFunctions.CollectPools()
				displayPoolsList()
				itm = ddl_outOfOrderMethod.selection
				spn_outOfOrderStep.enabled = itm >= 2 AND itm <= 4
				job_priority_update SMTDSettings.Priority
				
				
				SMTDSettings.SubmitSceneMode = #reposave
				SMTDSettings.RestartRenderer = true
				SMTDSettings.RenderElementsUpdatePaths = true
				SMTDSettings.RenderElementsUpdateFileNames = true
				SMTDSettings.RenderElementsPermanentChanges = true
				SMTDSettings.ClearMaterialEditorOnSubmission = true
				SMTDSettings.ExportAdvancedRenderInfoVRay = true
				
			)

			on LPM_DeadlineSubmitRo close do
			(
				saveSettings()
			)

			on btn_sanityCheck pressed do
			(
				try
				(
					SMTD_PerformSanityCheck()
				)
				catch
				(
					messagebox "Intstall Deadline3dsMaxClient.mcr\nfrom \"DeadlineRepository\submission\3dsmax\Client\"\nto make SanityCheck available."
				)
				
			)
			
			on btn_submit pressed do
			(
				renderSceneDialog.close()
				saveSettings()
				
				if SMTDSettings.RebuildRenderElements do
				(
					SMTDFunctions.RebuildRenderElements()
				)
				
				prg_submitProgress.value = 0
				--prg_submitProgress.visible = true
				btn_submit.enabled = btn_sanityCheck.enabled = false
				--grp_submit.text = "Submit progress"
				
				
				TmpVisualStyleMode = 0
				TmpUseTextureEnabled = 0
				
				try
				(
					TmpNitrousGraphicsManager = NitrousGraphicsManager.GetActiveViewportSetting()
					TmpVisualStyleMode = TmpNitrousGraphicsManager.VisualStyleMode
					TmpUseTextureEnabled = TmpNitrousGraphicsManager.UseTextureEnabled
				)
				catch()
				
				if chk_Viewboundbox.state then
				(
					TmpNitrousGraphicsManager.VisualStyleMode = #BoundingBox
					TmpNitrousGraphicsManager.UseTextureEnabled = false
				)
				
				try
				(
					SMTDSettings.RegionUseMaxValues = SMTDSettings.RegionRendering
				)
				catch
				(
				)
				
				renderCollect = LPM_Fun.getWhoToRender()
				flag=true
				for i=1 to renderCollect.count where flag do
				(
					prg_submitProgress.value = (100*(i-1))/renderCollect.count
					
					--Pre render action
					LPM_Render.fnPreRenderAction renderCollect[i][1] renderCollect[i][2]
					thePass=renderCollect[i][1]
					theShot=renderCollect[i][2]
					
					
					-- prepare Deadline Job
					try
					(
						TmpPass = renderCollect[i][1]
						
						TmpPassName = (LPM_Fun.getName TmpPass.name)
						
						if TmpPass.isAdjustment and (TmpPass.AdjustmentFor != undefined) then
						(
							TmpPassName = "["+(LPM_Fun.getName (TmpPass.AdjustmentFor.name)) + "]" + TmpPassName
						)
						
						if (theShot==undefined) then 
						(
							SMTDSettings.JobName = ( edt_Prefix.text + (getfilenamefile (maxfilename)) + " | P: "+TmpPassName + edt_Suffix.text)
						)
						else
						(
							SMTDSettings.JobName = ( edt_Prefix.text + (getfilenamefile (maxfilename)) + " | Sh: "+(LPM_Fun.getName renderCollect[i][2].name)+" | P: "+TmpPassName + edt_Suffix.text)
						)
						
						SMTDSettings.Comment = "LPM Submission"
						
						SMTDSettings.UserName = SMTDFunctions.GetDeadlineUser()
					)
					catch
					(
					)
					
					local result = SMTDFunctions.SubmitJob()
					if result != #success do
					(
						flag = false
						messagebox ("Error while submitting to Deadline (error code: "+result+")")
					)
					-- Deadline Job prepared and submitted
					
					LPM_Render.fnPostRenderAction renderCollect[i][1] renderCollect[i][2]
					if(keyboard.escPressed) then flag=false
				)
				
				try
				(
					TmpNitrousGraphicsManager = NitrousGraphicsManager.GetActiveViewportSetting()
					TmpNitrousGraphicsManager.VisualStyleMode = TmpVisualStyleMode
					TmpNitrousGraphicsManager.UseTextureEnabled = TmpUseTextureEnabled
				)
				catch()
				
				try(destroydialog LPM_DeadlineSubmitRo)catch()
				
			)
		)

		theNetworkRoot = ""

		flag=false

				if doesFileExist fnScript then
				(
					fileIn fnScript quiet:true
					flag=true
				)

		
		if(flag==false) then
		(
			return "Error Accessing Deadline. Change Deadline submission options in LPM settings"
		)
		
		try(destroyDialog LPM_RenderRo)catch()

		createDialog LPM_DeadlineSubmitRo lockHeight:true lockWidth:true style:#(#style_titlebar,#style_border, #style_sysmenu,#style_resizing,#style_minimizebox) pos:(LPM_Fun.getRoPos LPM_DeadlineSubmitRo.width)

		return #SUCCESS
	)	
)

append LPM_NetworkPlugins (LPM_DeadlineAPI())