

fn LPM_SetMultiformatFileName TmpFileName TmpType =
(
	FinalFileName = ""
	
	TmpFileNameName = getFileNameFile TmpFileName
	TmpFileNamePath = getFileNamePath TmpFileName
	
	frameNumber = (10000 + (currentTime as integer/ticksperframe)) as string
	framePadded = substring frameNumber 2 100
	
	if rendTimeType == 1 then
	(
		FinalFileName = TmpFileNamePath + TmpFileNameName + "." + TmpType
	)
	else
	(
		FinalFileName = TmpFileNamePath + TmpFileNameName + framePadded + "." + TmpType
	)
	
	FinalFileName
)

fn LPM_MultiformatConvert TmpFileName TmpType TmpDelete:false =
(
	TmpOldFileName = LPM_SetMultiformatFileName TmpFileName (substring (getFileNameType TmpFileName) 2 50)
	TmpNewFileName = LPM_SetMultiformatFileName TmpFileName TmpType
	
	TmpExeFilePath = "Multiformat.exe"
	TmpIMFFilePath = "imf_copy.exe"
	dosStartPath = ((getdir #scripts) + "\\LPM\\")

	comand_imf_copy =  " \"" + TmpOldFileName + "\" \"" + TmpNewFileName + "\""

	if TmpDelete then
	(
		comand_exe_param = " \"" + TmpOldFileName + "\" \"" + TmpNewFileName + "\""
	)
	else
	(
		comand_exe_param = " \"" + TmpOldFileName + "\" \"\""
	)

	comand_exe = TmpExeFilePath + " 5000 5000" + comand_exe_param + " " + TmpIMFFilePath + comand_imf_copy

	HiddenDOSCommand  comand_exe startpath: dosStartPath donotwait:true
	
)

fn LPM_node_startup = 
(
	try
	(
		
		if $LPM_Root != undefined then
		(
			LPM_Root = $LPM_Root
			
			try
			(
				
				if LPM_Root.PostConvert then
				(
					if (classof renderers.current==vray) then
					(
						vr = renderers.current
						filename = vr.output_rawFileName
						VrimgLocation = LPM_Root.PostConvertVrimg2exr
						VrimgCompression = LPM_Root.PostConvertCompression
						VrimgHalfFoat = LPM_Root.PostConvertHalfFoat
						VrimgDatawindow = LPM_Root.PostConvertDatawindow
						
						if (vr.output_on == true) and (vr.output_saveRawFile== true) and ((substring filename (filename.count-4) filename.count )== "vrimg") do
						(
							s1 = filename
							s2= ".vrimg"
							frameNumber = (10000 + (currentTime as integer/ticksperframe)) as string
							framePadded = substring frameNumber 2 100
							s3=framePadded + ".vrimg"
							filenamePadded = substituteString s1 s2 s3
							filenameFinal = "\""+filenamePadded+"\""
							tmpLaunchString = "" 
							
							tmpLaunchString += case VrimgCompression of
							(
								1:
								(
									" -compression none"
								)
								2:
								(
									" -compression rle"
								)
								3:
								(
									" -compression zips"
								)
								4:
								(
									" -compression zip"
								)
								5:
								(
									" -compression piz"
								)
								6:
								(
									" -compression pxr24"
								)
							)
							
							if  VrimgHalfFoat then
							(
								tmpLaunchString += " -half"
							)
							
							if  VrimgDatawindow then
							(
								tmpLaunchString += " -datawindow"
							)
							
							ShellLaunch VrimgLocation (filenameFinal + tmpLaunchString)
						)
					)
				)
				
			)
			catch
			(
				
			)
			
			if LPM_Root.PostRenderFrameScript then
			(
				try
				(
					execute LPM_Root.PostRenderFrameScriptText
				)
				catch
				(
				)
			)
			
			if LPM_Root.MultiformatMainOn then
			(
				try
				(
					
					LPM_MultiformatConvert LPM_Root.MultiformatMainFiles LPM_Root.MainImageType
				)
				catch()
			)
			
			if LPM_Root.MultiformatREOn then
			(
				try
				(
					
					for TmpREFile in LPM_Root.MultiformatREFiles do
					(
						
						LPM_MultiformatConvert TmpREFile LPM_Root.MultiformatREType TmpDelete:LPM_Root.MultiformatREDelete
					)
				)
				catch()
			)
			
			if LPM_Root.MultiformatAMOn then
			(
				try
				(
					
					for TmpAMFile in LPM_Root.MultiformatAMFiles do
					(
						
						LPM_MultiformatConvert TmpAMFile LPM_Root.MultiformatAMType TmpDelete:LPM_Root.MultiformatAMDelete
					)
				)
				catch()
			)
		)
		
	)
	catch
	(
		
	)
	
	
	
)

fn Prism_WaitForSave =
(
	try
	(
		LPM_Root = $LPM_Root
		if (LPM_Root.MultiformatMainOn) or (LPM_Root.MultiformatREOn) or (LPM_Root.MultiformatAMOn) then
		(
			TmpStartTime = timestamp()
			tmpDelta = 0
			
			do
			(
				tmpDelta = (timestamp()) - TmpStartTime
			)
			while tmpDelta<8000
		)
	)
	catch()
)


callbacks.addScript #postRender "Prism_WaitForSave()" id:#PrismWaitForSave

callbacks.addScript #postRenderFrame "LPM_node_startup()" id:#LPMnodeStartup
